package org.protux;

import java.awt.event.WindowEvent;

import javax.swing.JFrame;

import org.protux.core.Debugger;
import org.protux.core.Protux;
import org.protux.core.engines.audio.HardBusMapper;
import org.protux.core.gui.ProtuxContainer;
import org.protux.input.classic.MainMenu;

public class Main extends JFrame implements ProtuxContainer
	{

	protected Protux protux = null;
		public Main(String title)
			{
			super(title);
			protux = new Protux(this,"resources/",false);
			addWindowListener(this);
			MainMenu mainMenu = new MainMenu(protux);
			setJMenuBar(mainMenu);
			setApplication(protux);
			}


		public void setApplication(Protux protux)
			{
			this.protux = protux;
			this.add(protux);
			protux.init();
			}


		public Protux getApplication()
			{
			return protux;
			}


		public JFrame getWindow()
			{
			return this;
			}


		public void windowOpened(WindowEvent arg0)
			{
			}


		public void windowClosing(WindowEvent arg0)
			{
			destroy();
			}


		public void windowClosed(WindowEvent arg0)
			{
			}


		public void windowIconified(WindowEvent arg0)
			{
			}


		public void windowDeiconified(WindowEvent arg0)
			{
			}


		public void windowActivated(WindowEvent arg0)
			{
			}


		public void windowDeactivated(WindowEvent arg0)
			{
			}


		public void destroy()
			{
			if (protux.closed())
				{
				this.dispose();
				}
			}



		public static void main(String[] args)
			{
			Debugger.set_debug_level(Debugger.SUPER_FLOOD);
			System.setProperty("sun.java2d.opengl", "True");
			if (args.length > 1)
				{
				for (int i = 1; i < args.length; i++)
					{
					if (args[i].equals("--d1"))
						{
						Debugger.set_debug_level(Debugger.BASIC);
						}
					if (args[i].equals("--d2"))
						{
						Debugger.set_debug_level(Debugger.FLOOD);
						}
					if (args[i].equals("--d3"))
						{
						Debugger.set_debug_level(Debugger.SUPER_FLOOD);
						}
					if (args[i].equals("--d4"))
						{
						Debugger.set_debug_level(Debugger.ALL);
						}
					if (args[i].equals("--log"))
						{
						Debugger.create_log("protux.log");
						}
					if ((args[i].equals("--help")) || (args[i].equals("-h")))
						{
						System.out.println("\nUsage: protux [OPTIONS]");
						System.out.println("         Valid OPTIONS are :");
						System.out.println("               --d1  \t Set debug level to 1 (BASIC)");
						System.out.println("               --d2  \t Set debug level to 2 (FLOOD)");
						System.out.println("               --d3  \t Set debug level to 3 (SUPER_FLOOD)");
						System.out.println("               --d4  \t Set debug level to 4 (ALL)");
						System.out.println("               --log \t Create a ~/protux.log file instead of dumping debug messages to stdout");
						System.out.println("               --scanbuses \t List all hardware in and out buses");
						System.out.println("               --help or -h \t This help text");
						System.out.println("");
						}
					if ((args[i].equals("--scanbuses")) || (args[i].equals("-h")))
						{
						HardBusMapper.init();
						HardBusMapper.list_buses();
						}
					if (args[i].equals("--render"))
						{
						System.out.println("Render in batch mode is being implemented.");
						// TODO
						}
					if (args[i].equals("--renderwav"))
						{
						System.out.println("Render in batch mode is being implemented.");
						// TODO
						}
					}
				}
			new Main("Protux");
			}

	}
