package org.protux.core;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.Toolkit;

import javax.swing.Icon;
import javax.swing.ImageIcon;

public class Const
	{
	public static final int MONO = 1;
	public static final int STEREO = 2;
	public static final int ONLY_RIGHT_CHANNEL = 4; //< This is also an STEREO mode (but uses only RIGHT)
	public static final int ONLY_LEFT_CHANNEL = 3; //< This is also an STEREO mode (but uses only LEFT)
	public static final int CAPTURE = 1;
	public static final int PLAYBACK = 0;
	public static final int LEFT = 0;
	public static final int RIGHT = 1;
	public static final int LEFT_AND_RIGHT = 2;
	public static final int UP = 2; // Universal constant for Up
	public static final int DOWN = 3; // Universal constant for Down

	public static final String SONG_DIR_PREFIX = "SONG";
	public static final String SONG_PROPERTIES_FILE = "song.properties";
	public static final String SONG_SCHEMA_FILE = "schema.xml";
	public static final String PROJECT_PROPERTIES_FILE = "project.properties";
	public static final String RCFILE = ".protuxrc";
	public static final String DEFAULT_SONG_TITLE = "Cool Title";
	public static final String PRAF_EXTENSION = "praf";

	public static final boolean PEAK_LESS = true;
	public static final Font FONT_CLIP_INFO = new Font("Helvetica", 9, 9);
	public static final short MAX_SAMPLE = 32767; // 15 bits usigned short
	
	public static final int EDITING_MODE_NORMAL = 0;
	public static final int EDITING_MODE_CURVES = 1;
	public static final int JOG_MODE_CREATE_REGION = 0;
	public static final int MINIMUM_TRACK_HEIGHT = 30;
	public static final int STANDARD_TRACK_HEIGHT = 70;
	public static final int EDITOR_LOCATOR_HEIGHT = 40;
	public static final int PRAF_HEADER_LABEL_SIZE = 16;
	public static final int PRAF_HEADER_DESCRIPTION_SIZE = 56;
	public static final int PRAF_HEADER_SIZE = 256;
	public static final int PRAF_HEADER_RESERVED_SIZE = 128;
	public static final int WAV_COMMON_HEADER_SIZE = 44;
	public static final int READ_ONLY = 111;
	public static final int READ_AND_WRITE = 112;
	public static final int[] ZOOM_STEP = { 1, 2, 4, 6, 8, 12, 16, 20, 24, 32, 48, 64, 96, 128, 192, 256, 384, 512, 768, 1024, 1536, 2048, 3072, 4096, 6144, 8192, 12288, 16384, 24576, 32768, 49152, 65536 };
	public static final int MAX_ZOOM_LEVELS = ZOOM_STEP.length;
	public static final int MAX_ZOOM_STEP_INDEX = MAX_ZOOM_LEVELS - 1;
	public static final int MAX_ZOOM_USING_SOURCEFILE = 12;
	public static final int CLIP_INFO_AREA_HEIGHT = 16;
	public static final int CLIP_VERTICAL_UPPER_MARGIN = 1;
	public static final int CLIP_VERTICAL_LOWER_MARGIN = 1;
	public static final int EDITOR_AND_RACK_TRACKS_BASE_Y = EDITOR_LOCATOR_HEIGHT;
	public static final int TRACK_RACK_MINIMUM_WIDTH = 150;

	public static final int ACTION_SHOW_PROJECT_MANAGER = 1;
	public static final int ACTION_QUIT = 2;
	public static final int ACTION_IMPORT_AUDIO = 4;
	public static final int ACTION_SAVE_PROJECT = 8;
	public static final int ACTION_ZOOM_OUT = 11;
	public static final int ACTION_ZOOM_IN = 113;
	public static final int ACTION_SPLIT_CLIP = 114;
	public static final int ACTION_ADD_SOFT_IN = 15;
	public static final int ACTION_ADD_SOFT_OUT = 14;
	public static final int ACTION_TOGGLE_PLAY_STOP = 230;
	public static final int ACTION_ADD_TRACK = 32;
	public static final int ACTION_REMOVE_ACTIVE_TRACK = 33;

	
	public static final String LABEL_PLAY = "PLAY";
	public static final String LABEL_STOP = "STOP";

	public static final int DEPTH_8_BITS = 8;
	public static final int DEPTH_16_BITS = 16;
	public static final int DEPTH_24_BITS = 24;
	public static final int ERROR_INVALID_CARD = -10;
	public static final int ERROR_INVALID_BUS = -11;
	public static final int ERROR_INVALID_RATE_CHANNELS_OR_BITDEPTH = -12;
	public static final int ERROR_BUSY_BUS = -13;
	public static final int ERROR_CANNOT_INIT_MAPPER = -14;
	public static final int ERROR_CANNOT_OPEN_PLAYBACK_BUS = -15;
	public static final int ERROR_CANNOT_OPEN_CAPTURE_BUS = -16;
	public static final int ERROR_CANNOT_OPEN_BUS = -17;
	public static final int ERROR_MONO_BUS = -18;
	public static final int ERROR_BUS_DOES_NOT_SUPPORT_THIS_BIT_DEPTH = -21;
	public static final int ERROR_BUS_DOES_NOT_SUPPORT_THIS_CHANNELS = -22;
	public static final int ERROR_BUS_DOES_NOT_SUPPORT_THIS_SAMPLE_RATE = -23;
	public static final int ERROR_8_BITS_BANNED_IN_MUSTUX_APPLICATIONS = -25;
	public static final int ERROR_CANNOT_DEFINE_FORMAT = -26;
	public static final int ERROR_CANNOT_SET_PARAMS_ANY = -28;
	public static final int ERROR_UNDERRUN = -29;
	public static final int ERROR_OVERRUN = -30;
	public static final int SUGGESTED_FPS = 10;
	public static final int DEFAULT_NUM_SONGS = 1;
	public static final long FRAME_SLEEP_TIME = 25;
	public static final float MIN_GAIN = -25f;
	public static final float MAX_GAIN = 25f;
	public static final float MIN_PAN = -1f;
	public static final float MAX_PAN = 1f;
	public static final float DEFAULT_GAIN = -3f;

	public static final Dimension BUTTON_MAX_SIZE = new Dimension(100, 30);
	public static final Dimension MIN_PROTUX_SIZE = new Dimension(600,500);
	public static final int TOP_PANEL_WIDTH = 300;
	public static final int TOP_PANEL_HEIGHT = 80;
	public static final Dimension TOP_PANEL_SIZE = new Dimension(TOP_PANEL_WIDTH, TOP_PANEL_HEIGHT);


	}
