package org.protux.core;

import java.io.File;


public class Debugger
	{
	public static final int OFF = 0; //< no debug output at all
	public static final int BASIC = 1; //< only level 1 calls
	public static final int FLOOD = 2; //< level 1 , level 2 and constructors/destructor calls
	public static final int SUPER_FLOOD = 3; //< all previous plus low level JMB messages
	public static final int ALL = 4; //< all messages (including in timer loops)
	private static int ntabs = 0;
	private static int debugLevel = OFF;
	private static File logFile = null;
	private static String logFileName = null;
	private static boolean logging = false;


	public static void PENTER(String s)
		{
		System.out.println(">>> Entering "+s);
		}
	public static void PEXIT(String s)
		{
		System.out.println(">>> Exiting  "+s);
		}
	public static void setLevel(int lev)
		{
		debugLevel= lev;
		}



	public static void PMESG(int lev, String m)
		{
		if (debugLevel>= lev) 
			{
			System.out.println(m);
			}
		}

	@Deprecated
	public static void PERROR(String m)
		{
		System.out.println("ERROR : " + m);
		}

	@Deprecated
	public static void PERROR(Object obj, String m)
		{
		System.out.println("ERROR [ "+obj.getClass().getName()+" ] : " + m);
		}

	@Deprecated
	public static void PWARN(String m)
		{
		System.out.println("WARN: " + m);
		}

	public static void PMESG_END(String string)
		{
		// TODO Auto-generated method stub
		
		}



	public static void PMESG_START(String string)
		{
		// TODO Auto-generated method stub
		
		}




	private static void fill_tabs()
		{
		for (int i = 0; i < ntabs; i++)
			{
			System.out.print("|   ");
			}
		}


	private static String get_tabs()
		{
		String t = "";
		for (int i = 0; i < ntabs; i++)
			t += "   ";
		return t;
		}


	private void more_tabs()
		{
		ntabs++;
		}


	private void less_tabs()
		{
		ntabs--;
		}


	public static void set_debug_level(int lev)
		{
		debugLevel = lev;
		}


	public static int get_debug_level()
		{
		return debugLevel;
		}


	public static void create_log(String fn)
		{
		logFileName = "";//MIG String(getenv("HOME")) + "/" + fn;
		logFile = null; //MIG fopen((final char*)logFileName,"a+");
		if (logFile == null)
			{
			PERROR("Cannot create MustuxDebugger Log file " + fn);
			logging = false;
			}
		else
			{
			//MIG fclose(logFile);
			logging = true;
			}
		}


	private void close_log()
		{
		logging = false;
		}


	private void log(String s)
		{
		String sc = s;
		int len = s.length();
		logFile = null; //MIG fopen(logFileName, "a+");
		//MIG fwrite(sc, len, 1, logFile);
		//MIG fclose(logFile);
		}


	private boolean is_logging()
		{
		return logging;
		}
	public static void error(String unit, String method, String what)
		{
		System.out.println("[" + unit + "] - " + method + "() - ERROR : " +what);
		}
	public static void warn(String unit, String method, String what)
		{
		System.out.println("[" + unit + "] - " + method + "() - WARNING : " +what);
		}

	
	}
