package org.protux.core.editor;

import java.io.File;
import java.io.IOException;

import org.protux.core.exceptions.PeakException;
import org.protux.core.media.audio.AudioMedia;
import org.protux.core.media.audio.Praf;

public class AudioSourceList
	{
	// maybe this can be just an ArrayList of AudioMedia/Media, aggregated inside Project...
	
	public static final int MAX_AUDIO_SOURCES = 100;

	public AudioMedia list[] = new AudioMedia[MAX_AUDIO_SOURCES];



	public AudioSourceList()
		{
		for (int i = 0; i < MAX_AUDIO_SOURCES; i++)
			{
			list[i] = null;
			}
		}



	public int add(AudioMedia pAudio)
		{
		for (int i = 0; i < MAX_AUDIO_SOURCES; i++)
			{
			if (list[i] == null)
				{
				list[i] = pAudio;
				return 1;
				}
			}
		return -1;
		}



	public int remove(AudioMedia pAudio)
		{
		for (int i = 0; i < MAX_AUDIO_SOURCES; i++)
			{
			if (list[i] == pAudio)
				{
				list[i] = null;
				for (int j = i; j < MAX_AUDIO_SOURCES - 1; j++)
					list[j] = list[j + 1];
				return 1;
				}
			}
		return -1;
		}



	public int get_total_sources()
		{
		int total = 0;
		for (int i = 0; i < MAX_AUDIO_SOURCES; i++)
			if (list[i] != null)
				{
				total++;
				}
		return total;
		}



	public AudioMedia get_source_for_index(int i)
		{
		if ((i < 0) || (i > MAX_AUDIO_SOURCES - 1))
			{
			return null;
			}
		return list[i];
		}



	public AudioMedia get_audio_for_source(String sourcePureName)
		{
		AudioMedia au = null;
		for (int i = 0; i < MAX_AUDIO_SOURCES; i++)
			{
			if ((list[i] != null) && (list[i].getPureName().equals(sourcePureName)))
				{
				au = list[i];
				break;
				}
			}
		return au;
		}
	//eof



	public AudioMedia loadSource(String phisicalSourceFilename) throws IOException
		{
		AudioMedia am = new Praf(new File(phisicalSourceFilename));
		am.readHeader();
		try
			{
			am.buildPeaks();
			}
		catch (PeakException e)
			{
			// TODO Auto-generated catch block
			e.printStackTrace();
			}
		add(am);
		return am;
		}


	}
