package org.protux.core.editor;

import org.protux.plug.AudioPluginController;


public class Chain
	{
	public static final int MAX_CONTROLLERS = 20;
	public Controller controller[] = new Controller[MAX_CONTROLLERS];
	public int currentController;
	public Track parentTrack;
	boolean draggingNode;
	int originX;
	int originY;
	long originPos;
	float originValue;
	boolean isSelectingController;


	public Chain(Track pAssocTrack)
		{
		for (int k = 0; k < MAX_CONTROLLERS; k++)
			{
			controller[k] = null;
			}
		currentController = -1;
		parentTrack = pAssocTrack;
		draggingNode = false;
		isSelectingController = false;
		}


	@Override
	public void finalize()
		{
		for (int k = 0; k < MAX_CONTROLLERS; k++)
			{
			if (controller[k] != null)
				{
				controller[k] = null;
				System.gc();
				}
			}
		}


	void draw()
		{
		/*
		 int baseY = assocTrack.real_baseY();
		 int height = assocTrack.get_height();
		 QPainter* painter = assocTrack.get_painter();

		 if (assocTrack.is_active())
		 {
		 ColorManager.set_blur(ColorManager.CURVE_ACTIVE , false);
		 ColorManager.set_blur(ColorManager.FILTERCONTROLLER_ACTIVE, false);
		 ColorManager.set_blur(ColorManager.CURVE_NONACTIVE , false);
		 ColorManager.set_blur(ColorManager.FILTERCONTROLLER_NONACTIVE, false);
		 }
		 else
		 {
		 ColorManager.set_blur(ColorManager.CURVE_ACTIVE , true);
		 ColorManager.set_blur(ColorManager.FILTERCONTROLLER_ACTIVE, true);
		 ColorManager.set_blur(ColorManager.CURVE_NONACTIVE , true);
		 ColorManager.set_blur(ColorManager.FILTERCONTROLLER_NONACTIVE, true);
		 }

		 // draw the controllers queue
		 painter.setPen(QColor(0,0,100));
		 painter.setFont(QFont("Fixed",6));
		 int by = baseY + height - 25;
		 int y1 = by + 6;
		 QColor cf;
		 int j=0;
		 for (int k=0; k<MAX_CONTROLLERS; k++)
		 {
		 if (pluginController[k])
		 {
		 int bx = 15 + j*80;
		 int x1 = bx - 10;
		 painter.setPen(Qt.black);
		 painter.moveTo(x1,   y1);
		 painter.lineTo(x1+5, y1);
		 painter.lineTo(x1+5, y1-4);
		 painter.lineTo(x1+8, y1+4);
		 painter.lineTo(x1+5, y1+11);
		 painter.lineTo(x1+5, y1+7);
		 painter.lineTo(x1,   y1+7);

		 String filterType = pluginController[k].get_type();
		 if (pluginController[k].get_audio_plugin().is_bypassed())
		 cf = CM_COLOR(FILTERCONTROLLER_NONACTIVE);
		 else
		 {
		 if (k==currentAudioPluginController)
		 {
		 pluginController[k].get_current_curve().activate();
		 cf = CM_COLOR(FILTERCONTROLLER_ACTIVE);
		 }
		 else
		 {
		 pluginController[k].get_current_curve().deactivate();
		 cf = CM_COLOR(FILTERCONTROLLER_NONACTIVE);
		 }
		 }
		 String currentCurveName = pluginController[k].get_current_curve().get_type();
		 painter.fillRect(bx,   by,    70, 19, cf);
		 painter.setPen(Qt.black);
		 painter.drawRect(bx,   by,    70, 19);
		 painter.drawText(bx+3, by+9, filterType);
		 painter.drawText(bx+3, by+17, currentCurveName);
		 j++;
		 }
		 }

		 for (int k=0; k<MAX_CONTROLLERS; k++)
		 {
		 if (pluginController[k])
		 pluginController[k].draw();
		 }
		 */
		}


	AudioPluginController add_audio_plugin_controller(String filterName)
		{
		
		return null;// FIXME
		/*
		 int fcIndex=-1;

		 for (int k=0; k<MAX_CONTROLLERS; k++)
		 {
		 if (!pluginController[k])
		 {
		 fcIndex=k;
		 //			assocTrack.parentSong.recreate_clip_area();
		 break;
		 }
		 }
		 if (fcIndex<0)
		 {
		 //PERROR("Max number of filter controllers reached for track %s", (const char*) assocTrack.get_name().latin1());
		 
		 return (AudioPluginController*) 0;
		 }
		 PMESG("Allocating %s controller in slot %d",(const char*) filterName.latin1() ,fcIndex);
		 if (filterName=="")
		 {
		 assocTrack.parentSong.parentProject.parentInterface.info("Ok... no filter added :-/",1);
		 
		 return (AudioPluginController*) 0;
		 }
		 if (filterName=="Gain")
		 {
		 pluginController[fcIndex]=new GainController(this);
		 }
		 else
		 if (filterName=="Pan")
		 {
		 pluginController[fcIndex]=new PanController(this);
		 }
		 else
		 if (filterName=="Noise Gate")
		 {
		 pluginController[fcIndex]=new NoiseGateController(this);
		 }
		 else
		 if (filterName=="Delay")
		 {
		 pluginController[fcIndex]=new DelayController(this);
		 }
		 //else if (filterName=="...
		 else
		 {
		 assocTrack.parentSong.parentProject.parentInterface.info("Filter/Controller not implemented yet");
		 
		 return (AudioPluginController*) 0;
		 }
		 pluginController[fcIndex].setupFrontend.setCaption(pluginController[fcIndex].get_type()+" Controller Setup");
		 set_current_audio_plugin_controller(fcIndex);
		 assocTrack.recreate(); // should be recreate_mta
		 
		 return pluginController[currentAudioPluginController];
		 */
		}


	int set_current_audio_plugin_controller(AudioPluginController fc)
		{
		//PENTER2;
		for (int k = 0; k < MAX_CONTROLLERS; k++)
			if ((controller[k] != null) && (controller[k] == fc))
				{
				//PEXIT2;
				return set_current_audio_plugin_controller(k);
				}
		return -1;
		//PEXIT2;
		}


	int set_current_audio_plugin_controller(int index)
		{
		//PENTER2;
		if ((index >= 0) && (index < MAX_CONTROLLERS) && (controller[index] != null))
			{
			for (int k = 0; k < MAX_CONTROLLERS; k++)
				if (controller[k] != null)
					{
					//MIG pluginController[k].deactivate();
					}
			currentController = index;
			//MIG if (Jmb.get_current_mode() ==  assocTrack.parentSong.CurveMode)
			//MIG pluginController[currentAudioPluginController].activate();
			//PEXIT2;
			return 1;
			}
		//PEXIT2;
		return -1;
		}


	void select_controller(boolean isBeginning)
		{
		isSelectingController = isBeginning;
		}


	int remove_controller(AudioPluginController fc)
		{
		//PENTER2;
		/*MIG
		 for (int k=0; k<MAX_CONTROLLERS; k++)
		 {
		 if (pluginController[k] && pluginController[k]==fc)
		 {
		 //PEXIT2;
		 return remove_controller(k);
		 }
		 }*/
		return -1;
		//PEXIT2;
		}


	int remove_controller(int index)
		{
		//PENTER2;
		if (index == -1)
			index = currentController;
		if (currentController >= 0)
			{
			//delete (pluginController[currentAudioPluginController]);
			controller[currentController] = null;
			currentController = -1;
			for (int k = 0; k < MAX_CONTROLLERS; k++)
				{
				//MIG 	if (pluginController[k])
				//MIG 	{
				//MIG currentAudioPluginController=k;
				//MIG pluginController[currentAudioPluginController].activate();
				//MIG break;
				//MIG 				}
				}
			//MIG assocTrack.recreate_clip_area();
			//PEXIT2;
			return 1;
			}
		//PEXIT2;
		return -1;
		}


	void followMouse(int x, int y)
		{
		//PENTER4;
		if (isSelectingController)
			{
			int ncs = 0;
			for (int k = 0; k < MAX_CONTROLLERS; k++)
				//MIG if (pluginController[k]) ncs++;
				if (ncs == 0)
					{
					//PEXIT4;
					return;
					}
			//MIG int index = x/(assocTrack.get_width()/ncs) + 1;
			int i = 0;
			for (int k = 0; k < MAX_CONTROLLERS; k++)
				{
				//MIG if (pluginController[k]) i++;
				//MIG 			if (i==index)
				//MIG 				{
				//MIG 				set_current_audio_plugin_controller(k);
				//MIG 				break;
				//MIG 				}
				}
			//MIG assocTrack.recreate_clip_area();
			//PEXIT4;
			return;
			}
		// NODE/CURVE MANIPULATION
		//MIG 	if (
		//MIG 		(currentAudioPluginController<0) ||
		//MIG 		(Jmb.get_current_mode() == assocTrack.parentSong.CurveMode) ||
		//MIG 		((!draggingNode) && (!assocTrack.is_pointed(y)))
		//MIG 	    )
		//MIG 	    	{
		//MIG 			//PEXIT4;
		//MIG 			return;
		//MIG 			}
		long lpos = 0;//MIG assocTrack.parentSong.xpos_to_block(x);
		if (lpos < 0)
			{
			//PEXIT4;
			return;
			}
		float cv = 0.0f;//MIG pluginController[currentAudioPluginController].get_current_curve().get_value_at(lpos);
		/* improveme
		 MustuxLcd* lcd = assocTrack.parentSong.parentProject.get_default_lcd();
		 lcd.clear(550,100,100,20);
		 p.setPen(Qt.black);
		 String scv; scv.setNum(cv);
		 p.setFont(QFont("Fixed",8));
		 p.drawText(560,100,scv);
		 lcd.update(550,100,100,20);
		 */
		/*MIG
		 if (draggingNode)
		 {
		 CurveNode cn = pluginController[currentAudioPluginController].get_current_curve().get_current_curve_node();
		 if (cn.prev) // This is to avoid changing the root node position
		 {
		 long pos = assocTrack.parentSong.xpos_to_block( x - originX ) + originPos;
		 if(cn.prev.pos > pos)
		 pos=cn.prev.pos + 4;
		 if (cn.next)
		 if(cn.next.pos < pos)
		 pos=cn.next.pos - 4;
		 cn.set_pos(pos);
		 }
		 int half = assocTrack.get_height()/2;
		 int dy = y - originY;
		 float variation = -100.0 * ( ( (float) ( dy - half) / half ) + 1.0 );
		 float v = originValue + variation;
		 cn.set_value(v);
		 assocTrack.recreate_clip_area();
		 }
		 else if (assocTrack.is_pointed(y))
		 pluginController[currentAudioPluginController].update_current_node(x);
		 //PEXIT4;*/
		}


	void drag_node(boolean isBeginning)
		{
		draggingNode = isBeginning;
		if ((draggingNode) && (currentController >= 0))
			{
			//MIG originX = assocTrack.get_mouse_x();
			//MIG originY = assocTrack.get_mouse_y();
			//MIG originPos   = pluginController[currentAudioPluginController].get_current_curve().get_current_curve_node().pos;
			//MIG originValue = pluginController[currentAudioPluginController].get_current_curve().get_current_curve_node().value;
			}
		}


	void add_node()
		{
		//PENTER3;
		/*MIG	if (currentAudioPluginController>=0)
		 {
		 int x = assocTrack.get_mouse_x();
		 int y = assocTrack.get_mouse_y();
		 long pos  = assocTrack.parentSong.xpos_to_block(x);
		 int half = assocTrack.get_height()/2;
		 float value = -100.0 * ((float) ((y - assocTrack.get_baseY()) - half) / half );
		 pluginController[currentAudioPluginController].get_current_curve().add_node(pos, value);
		 assocTrack.recreate_clip_area();
		 }
		 //PEXIT3;
		 * 
		 */
		}


	public void node_setup()
		{
		if (currentController >= 0)
			{
			//MIG pluginController[currentAudioPluginController].node_setup();
			//MIG assocTrack.recreate_clip_area();
			}
		}


	public void audio_plugin_setup()
		{
		if (currentController >= 0)
			{
			//MIG pluginController[currentAudioPluginController].setup();
			//MIG assocTrack.recreate_clip_area();
			}
		}


	public int process(char[] data, int size)
		{
		//PENTER4;
		for (int k = 0; k < MAX_CONTROLLERS; k++)
			{
			//MIG if (pluginController[k])pluginController[k].process(data,size);
			}
		//PEXIT4;
		return 1;
		}


	public int cleanup()
		{
		for (int k = 0; k < MAX_CONTROLLERS; k++)
			{
			//MIG if (pluginController[k]) pluginController[k].cleanup();
			}
		return 1;
		}


	public void activate()
		{
		
		//MIG if (currentAudioPluginController>=0) pluginController[currentAudioPluginController].activate();
		// maybe some things more here ...
		
		}


	public void deactivate()
		{
		
		//MIG if (currentAudioPluginController>=0) pluginController[currentAudioPluginController].deactivate();
		
		}


	public String get_schema()
		{
		
		String schema = "";
		for (int k = 0; k < MAX_CONTROLLERS; k++)
			{
			if (controller[k] != null)
				{
				//MIG schema += "       <filtercontroller type=\"" + pluginController[k].get_type() + "\">\n";
				//MIG schema += pluginController[k].get_schema();
				schema += "       </filtercontroller>\n";
				}
			}
		
		return schema;
		}
	//	
	}
