package org.protux.core.engines.audio;

import java.util.ArrayList;

import org.protux.core.Const;
import static org.protux.core.Debugger.*;

public class AudioCard
	{
		
		static ArrayList<BusMode> busMode = new ArrayList<BusMode>();

		private String shortName;
		private String fullName;


		public String getFullName()
			{
			return fullName;
			}


		public void setFullName(String cardFullName)
			{
			this.fullName = cardFullName;
			}


		public String getShortName()
			{
			return shortName;
			}


		public void setShortName(String cardShortName)
			{
			this.shortName = cardShortName;
			}


		public boolean isValidMode(int pRate, int pBitDepht, int pChannels)
			{
			for (BusMode bm : busMode)
				{
				if ((pRate == bm.rate) && (pBitDepht == bm.bitDepht) && (pChannels == bm.channels))
					{
					return true;
					}
				}
			return false;
			}


		private int supports(int pRate, int pBitDepht, int pChannels, int pStream)
			{
			PcmHandle pcmHandle = null;
			int channelsMax = 0;
			int error = 0;
			if (pBitDepht == 8)
				{
				return Const.ERROR_8_BITS_BANNED_IN_MUSTUX_APPLICATIONS;
				}
			if (get_format(pBitDepht) < 0)
				{
				return Const.ERROR_CANNOT_DEFINE_FORMAT;
				}
			snd_pcm_hw_params_t tempHwParams = null;
			if (pStream == Const.CAPTURE)
				{
				try
					{
					snd_pcm_open(pcmHandle, (get_real_descriptor()), SND_PCM_STREAM_CAPTURE, 0);
					}
				catch (Exception ex)
					{
					PERROR("Error : " + ex);
					return Const.ERROR_CANNOT_OPEN_BUS;
					}
				}
			else
				{
				try
					{
					snd_pcm_open(pcmHandle, (get_real_descriptor()), SND_PCM_STREAM_PLAYBACK, SND_PCM_NONBLOCK);
					}
				catch (Exception ex)
					{
					PERROR("The playback device %s is allready in use by another application, please stop this application and restart this program" + (get_real_descriptor()));
					return Const.ERROR_CANNOT_OPEN_PLAYBACK_BUS;
					}
				}
			snd_pcm_hw_params_alloca(tempHwParams);
			if (snd_pcm_hw_params_any(pcmHandle, tempHwParams) < 0)
				{
				snd_pcm_close(pcmHandle);
				return Const.ERROR_CANNOT_SET_PARAMS_ANY;
				}
			if (snd_pcm_hw_params_test_rate(pcmHandle, tempHwParams, pRate, 0) != 0)
				{
				snd_pcm_close(pcmHandle);
				return Const.ERROR_BUS_DOES_NOT_SUPPORT_THIS_SAMPLE_RATE;
				}
			int format = 0;
			if (snd_pcm_hw_params_test_format(pcmHandle, tempHwParams, format) != 0)
				{
				snd_pcm_close(pcmHandle);
				return Const.ERROR_BUS_DOES_NOT_SUPPORT_THIS_BIT_DEPTH;
				}
			snd_pcm_hw_params_get_channels_max(tempHwParams, channelsMax);
			if (error < 0)
				{
				PERROR("Cannot detect max number of channels");
				}
			if (snd_pcm_hw_params_test_channels(pcmHandle, tempHwParams, channelsMax) != 0)
				{
				snd_pcm_close(pcmHandle);
				return Const.ERROR_BUS_DOES_NOT_SUPPORT_THIS_CHANNELS;
				}
			snd_pcm_close(pcmHandle);
			return error;
			}


		private int snd_pcm_hw_params_test_format(PcmHandle pcmHandle, snd_pcm_hw_params_t tempHwParams, int format)
			{
			return 0;
			}


		private void snd_pcm_open(PcmHandle pcmHandle, String string, int snd_pcm_stream_capture2, int i)
			{
			}


		/* MIG !!!! ---------------------------------------------------- */
		private String get_real_descriptor()
			{
			return null;
			}
		private class snd_pcm_hw_params_t extends Object
			{
			}

		private class PcmHandle extends Object
			{
			}


		private void snd_pcm_hw_params_alloca(snd_pcm_hw_params_t tempHwParams)
			{
			}


		private int get_format(int x)
			{
			return -1;
			}


		private void snd_pcm_hw_params_get_channels_max(snd_pcm_hw_params_t tempHwParams, int channelsMax)
			{
			}


		private int snd_pcm_hw_params_any(PcmHandle pcmHandle, snd_pcm_hw_params_t tempHwParams)
			{
			return 0;
			}


		private int snd_pcm_hw_params_test_rate(PcmHandle pcmHandle, snd_pcm_hw_params_t tempHwParams, int rate, int i)
			{
			return 0;
			}


		private void snd_pcm_close(PcmHandle pcmHandle)
			{
			}


		private int snd_pcm_hw_params_test_channels(PcmHandle pcmHandle, snd_pcm_hw_params_t tempHwParams, int channelsMax)
			{
			return 0;
			}

		private static final int SND_PCM_NONBLOCK = 0;

		private static final int SND_PCM_STREAM_PLAYBACK = 0;

		private static final int SND_PCM_STREAM_CAPTURE = 0;
		/* MIG !!!! ---------------------------------------------------- */
	}
