package org.protux.core.engines.audio;

import static org.protux.core.Debugger.PMESG;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.util.ArrayList;
import javax.swing.JPanel;


public abstract class BusContainer extends JPanel
	{

		protected ArrayList<Bus> busList = new ArrayList<Bus>();
		protected Bus defaultBus = null;
		protected String containerName = null;


		public BusContainer(String name)
			{
			super();
			this.containerName = name;
			this.setLayout(new GridLayout(1,10));
			}


		public abstract Bus createBus(String name,Bus.Direction direction);


		public final Bus addBus(Bus bus)
			{
			busList.add(bus);
			this.add(bus);
			if (defaultBus == null)
				defaultBus = bus;
			recreateBuses();
			return bus;
			}


		public final Bus addNullBus(Bus.Direction direction)
			{
			Bus nb = createBus("New Null Bus", direction);
			nb.setNull(true);
			return nb;
			}


		public void recreateBuses()
			{
			for (Bus bus : busList)
				{
				bus.recreate();
				}
			}


		private void log(String string)
			{
			PMESG(2, "[ Bus Container "+containerName+" ] " + string);
			}


		public Bus getDefaultBus()
			{
			return defaultBus;
			}

	}
