package org.protux.core.engines.audio;

import static org.protux.core.Debugger.PERROR;
import static org.protux.core.Debugger.PMESG;


public class SimpleAudioPlayer
	{

	float gain;
	boolean isPlaying;
	boolean play;
	boolean usePlughw;
	String sourceFileName;
	String busDescriptor;


	public SimpleAudioPlayer()
		{
		busDescriptor = "";
		sourceFileName = "";
		gain = 0;
		isPlaying = false;
		play = false;
		usePlughw = false;
		}


	@Override
	public void finalize()
		{
		if (isPlaying)
			{
			stop();
			// It could take a while before the playThread has finished execution.
			// since it uses this MustuxAudioPlayer object we have to wait destroying it
			// until isPlaying is false.
			while (isPlaying)
				{
				//MIG sleep (100);
				}
			}
		}


	public int start()
		{
		if (isPlaying)
			{
			PMESG(3, "Allready playing a file");
			return -1;
			}

		if (sourceFileName == "")
			{
			PERROR("No file specified to play");
			return -1;
			}
		play = true;

		/*MIG 	struct sched_param rtparam;
		 int x;
		 rtparam.sched_priority = 50;
		 pthread_t playThread;
		 
		 pthread_create (&playThread, 0, play_audio_thread, this);
		 
		 if ((x = pthread_setschedparam (playThread, SCHED_FIFO, &rtparam)) != 0)
		 {
		 //Do nothing, this warning is allready handled in MADM
		 //PWARN("Cannot set playFromSourceThread to real-time priority: %d", rtparam.sched_priority);
		 }
		 
		 // Not sure if this will do, but lets wait a second so the Playthread can start up.
		 // if it starts up, isPlaying can be set so we can return it ;-)
		 while(!isPlaying && play)
		 usleep(10000);
		 
		 if (isPlaying)
		 return 1;*/

		return -1;
		}


	public int stop()
		{
		play = false;
		return 1;
		}


	public boolean is_playing()
		{
		return isPlaying;
		}


	public void set_use_plughw(boolean use)
		{
		usePlughw = use;
		HardBusMapper.set_plughw_use(usePlughw);
		}


	public void set_source_file(String fileName)
		{
		sourceFileName = fileName;
		}


	public void set_bus_out_descriptor(String descriptor)
		{
		busDescriptor = descriptor;
		}


	public void set_gain(float g)
		{
		gain = g;
		}

	/*MIG
	 void* play_audio_thread(void *arg)
	 {
	 MustuxAudioPlayer* map = (MustuxAudioPlayer*) arg;
	 
	 boolean valid = true;
	 
	 AudioMedia inputFile = null;
	 
	 if (map.sourceFileName.find("praf",0,false)>=0)	//FIXME There should be a method in MADM like get_file_type(). If it is implemented, use that instead of this crap!!!
	 {
	 inputFile = new PrafFile();
	 }
	 else if (map.sourceFileName.find("wav", 0,false)>=0)
	 {
	 inputFile = new WavFile();
	 }

	 else if (map.sourceFileName.find("ogg", 0,false)>=0)
	 {
	 inputFile = new OggFile();
	 }

	 else
	 {
	 valid = false;
	 }

	 if (valid)
	 {
	 if (inputFile.open(map.sourceFileName) != 1)
	 {
	 PERROR("Could not open selected file!");
	 valid = false;
	 delete inputFile;
	 }
	 }

	 if (valid)
	 {
	 if (inputFile.read_header() != 1)
	 {
	 PMESG(3,"This is not a PRAF, WAV or OGG file");
	 valid = false;
	 delete inputFile;
	 }
	 }

	 int busId, rate, bitDepth, channels;
	 if (valid)
	 {
	 inputFile.get_info();
	 rate = inputFile.rate;
	 bitDepth = inputFile.bitDepth;
	 channels = inputFile.channels;
	 String desc = map.busDescriptor;
	 if (desc == "")
	 {
	 busId = AudioDeviceMapper.find_bus_out(rate,bitDepth,channels);
	 if (busId<0)
	 {
	 busId=AudioDeviceMapper.get_bus_out_index_for_descriptor("hw:0,0");
	 if (busId<0)
	 busId=AudioDeviceMapper.get_bus_out_index_for_descriptor("plughw:0,0");
	 if (busId<0)
	 {
	 PERROR("Cannot find a bus to prelisten the audio");
	 valid = false;
	 delete inputFile;
	 }
	 }
	 }
	 else
	 {
	 if (map.usePlughw)
	 desc.prepend("plug");
	 busId=AudioDeviceMapper.get_bus_out_index_for_descriptor(desc);
	 }
	 
	 if (valid)
	 {
	 if (AudioDeviceMapper.open_bus_out(busId,rate,bitDepth,channels==2?AudioDeviceMapper.STEREO:AudioDeviceMapper.MONO) < 0)
	 {
	 PERROR("Cannot open bus out");
	 valid = false;
	 delete inputFile;
	 }
	 }
	 }

	 if (valid)
	 {
	 map.isPlaying = true;
	 char *buffer = AudioDeviceMapper.get_bus_out_transfer_buffer(busId, inputFile.channels);
	 int bufferSize = AudioDeviceMapper.get_bus_out_transfer_size(busId);
	 while ( map.play && inputFile.read_fragment(buffer, bufferSize))
	 {
	 char* p = buffer;
	 char* lastp = p + bufferSize;
	 float gain = map.gain;
	 float gainFactor = (gain>=0.0f)? 1.0f + gain/6.0f : 1.0f / pow(2.0f,-1.0f*gain/6.0f);
	 while (p<lastp)
	 {
	 for (int k=0; k<channels; k++)
	 {
	 short* psho = (short*)p;
	 short sample = *(psho);
	 float fsample = (float) sample * gainFactor;
	 // COMMENTED BY GIORDANa
	 // NOT COMPILING!!!
	 // CHECK_SAMPLE_OVERLOAD(fsample);
	 *(psho)= (short) fsample;
	 p+=sizeof(short);
	 }
	 }
	 AudioDeviceMapper.bus_out_transfer(busId);
	 }

	 AudioDeviceMapper.clean_bus_out(busId);
	 AudioDeviceMapper.close_bus_out(busId);
	 inputFile.close_file();
	 }

	 map.isPlaying = false;
	 map.play = false;
	 pthread_exit((void*)0);

	 }
	 */

	}
