package org.protux.core.engines.audio;

import java.awt.Choice;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;

import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;

public class SoftBus extends Bus implements ItemListener
	{
		HardBus assocHardBus = null;
		JComboBox hbusesChoice;
		protected static int currentSoftId = 0;


		public SoftBus(String name, Direction direction)
			{
			super(++currentSoftId, false, name, direction);
			hbusesChoice.addItemListener(this);
			}


		private final ArrayList<HardBus> getAvailableHardBuses()
			{
			ArrayList<HardBus> availableHardBuses = new ArrayList<HardBus>();
			if (direction == Direction.IN)
				for (HardBus b : HardBusMapper.getAllIn())
					availableHardBuses.add(b);
			if (direction == Direction.OUT)
				for (HardBus b : HardBusMapper.getAllOut())
					availableHardBuses.add(b);
			return availableHardBuses;
			}


		public HardBus getHardBus()
			{
			return assocHardBus;
			}


		public void setHardBus(HardBus bus)
			{
			assocHardBus = bus;
			}


		@Override
		protected ArrayList<JComponent> getExtraButtons()
			{
			ArrayList<JComponent> xbuttons = new ArrayList<JComponent>();
			refreshAvailableHardBuses();
			xbuttons.add(hbusesChoice);
			return xbuttons;
			}


		private void refreshAvailableHardBuses()
			{
			if (hbusesChoice == null)
				{
				hbusesChoice = new JComboBox();
				}
			hbusesChoice.removeAll();
			for (HardBus b : getAvailableHardBuses())
				{
				String s = b.getBusName();
				hbusesChoice.addItem(s);
				}
			}


		public void itemStateChanged(ItemEvent item)
			{
			Object source = item.getSource();
			if (source == hbusesChoice)
				{
				Choice c = (Choice) source;
				String s = c.getSelectedItem();
				HardBus hb = HardBusMapper.getHardBusByName(s);
				this.assocHardBus = hb;
				}
			}
	}
