package org.protux.core.gui;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionListener;

import javax.swing.Icon;
import javax.swing.JButton;

public class Button extends JButton
	{
		public static final Dimension BUT_BUS_SIZE = new Dimension(30, 16);


		public Button(String label)
			{
			this(null, null, BUT_BUS_SIZE);
			setText(label);
			}


		public Button(String label, Dimension size)
			{
			this(null, null, size);
			setText(label);
			}


		public Button(ActionListener listener, Icon icon)
			{
			this(listener, icon, BUT_BUS_SIZE);
			}


		public Button(ActionListener listener, Icon icon, Dimension size)
			{
			if (icon != null)
				setIcon(icon);
			setFont(new Font("Helvetica", Font.BOLD, 10));
			setMinimumSize(size);
			setPreferredSize(size);
			setMaximumSize(size);
			setSize(size);
			addActionListener(listener);
			}
	}
