package org.protux.core.gui;

import java.awt.Dimension;

import javax.swing.JButton;
import javax.swing.JToolBar;

import org.protux.core.Const;
import org.protux.core.Protux;

public class ButtonBar extends JToolBar
	{
	private static final Dimension MIN_BUTTON_BAR_DIM = new Dimension(300, 16);

	private static final Dimension BUT_SIZE=new Dimension(30,20);
	public Button buttonRec = new Button("REC",BUT_SIZE);
	public Button buttonLoop = new Button("LOOP",BUT_SIZE);
	public Button buttonTogglePlay = new Button(Const.LABEL_PLAY,BUT_SIZE);
	public Button buttonPause = new Button("||",BUT_SIZE);
	public Button buttonRewind = new Button("|<",BUT_SIZE);
	public Button buttonGoToEnd = new Button(">|",BUT_SIZE);

	public ButtonBar()
		{
		super();
		add(buttonRec);
		add(buttonLoop);
		add(buttonTogglePlay);
		add(buttonPause);
		add(buttonRewind);
		add(buttonGoToEnd);
		buttonRec.addActionListener(Protux.appSingleton);
		buttonLoop.addActionListener(Protux.appSingleton);
		buttonPause.addActionListener(Protux.appSingleton);
		buttonRewind.addActionListener(Protux.appSingleton);
		buttonGoToEnd.addActionListener(Protux.appSingleton);
		buttonTogglePlay.addActionListener(Protux.appSingleton);
		buttonRec.setToolTipText("Record from current work position");
		buttonLoop.setToolTipText("Play current regions in loop");
		buttonPause.setToolTipText("Pause");
		buttonRewind.setToolTipText("Rewind");
		buttonGoToEnd.setToolTipText("Go to end");
		buttonTogglePlay.setToolTipText("Play/Stop <SPACE> , Play from beginning <ALT SPACE>, Play Loop <B SPACE>");
		setMinimumSize(MIN_BUTTON_BAR_DIM);
		setPreferredSize(MIN_BUTTON_BAR_DIM);
		setSize(MIN_BUTTON_BAR_DIM);
		}
	}
