package org.protux.core.gui;

import java.awt.Color;

public class ColorManager
	{
	public static final int MAX_COLORS = 43;
	public static final boolean BLUR = true;
	// Generic Colors
	public static final int CM_RED = 0;
	public static final int CM_GREEN = 1;
	public static final int CM_BLUE = 2;
	public static final int CM_YELLOW = 3;
	public static final int CM_ORANGE = 4;
	public static final int CM_CYAN = 5;
	public static final int CM_MAGENTA = 6;
	public static final int CM_LIGHT_RED = 7;
	public static final int CM_LIGHT_GREEN = 8;
	public static final int CM_LIGHT_BLUE = 9;
	public static final int CM_LIGHT_YELLOW = 10;
	public static final int CM_LIGHT_ORANGE = 11;
	public static final int CM_LIGHT_CYAN = 12;
	public static final int CM_LIGHT_MAGENTA = 13;
	public static final int CM_GRAY = 14;
	public static final int CM_WHITE = 15;
	public static final int CM_DARK_TEXT = 16;
	public static final int CM_MEDIUM_TEXT = 17;
	public static final int CM_LIGHT_TEXT = 18;
	// Track Specific Colors
	public static final int CM_TRACK_BG = 19;
	public static final int CM_TRACK_BG_ACTIVE = 20;
	public static final int CM_TRACK_PANEL_BG = 21;
	public static final int CM_TRACK_PANEL_BG_ACTIVE = 22;
	// Clip Specific Colors
	public static final int CM_CLIP_BG = 23;
	public static final int CM_CLIP_BG_ACTIVE = 24;
	public static final int CM_CLIP_BG_SELECTED = 25;
	public static final int CM_CLIP_BG_MUTED = 26;
	public static final int CM_CLIP_INFO_AREA_BG = 27;
	public static final int CM_CLIP_INFO_AREA_BG_ACTIVE = 28;
	public static final int CM_CLIP_PEAK_MICROVIEW = 29;
	public static final int CM_CLIP_PEAK_MACROVIEW = 30;
	public static final int CM_CLIP_PEAK_OVERLOADED_SAMPLE = 32;
	//Curves/FilterController colors
	public static final int CM_CURVE_ACTIVE = 33;
	public static final int CM_CURVE_NONACTIVE = 34;
	public static final int CM_FILTERCONTROLLER_ACTIVE = 35;
	public static final int CM_FILTERCONTROLLER_NONACTIVE = 36;
	//BusMonitor colors
	public static final int CM_BUS_BACKGROUND = 37;
	public static final int CM_BUS_BACKGROUND_ACTIVE = 38;
	public static final int CM_CARD_INFO_BACKGROUND = 39;
	public static final int CM_BUS_LEVEL_CLEAR_COLOR = 40;
	public static final int CM_BUS_BACKGROUND_GREYD_OUT = 41;
	public static final int CM_BUS_LEVEL_CLEAR_COLOR_GREYD_OUT = 42;
	private static Color color[] = new Color[MAX_COLORS];
	private static boolean blur[] = new boolean[MAX_COLORS];



	public static void init()
		{
		for (int i = 0; i < MAX_COLORS; i++)
			{
			blur[i] = false;
			}
		color[CM_RED] = new Color(255, 0, 0);
		color[CM_GREEN] = new Color(0, 255, 0);
		color[CM_BLUE] = new Color(0, 0, 255);
		color[CM_YELLOW] = new Color(255, 255, 0);
		color[CM_ORANGE] = new Color(255, 200, 0);
		color[CM_CYAN] = new Color(0, 255, 255);
		color[CM_MAGENTA] = new Color(255, 0, 255);
		color[CM_LIGHT_RED] = new Color(255, 180, 180);
		color[CM_LIGHT_GREEN] = new Color(180, 255, 180);
		color[CM_LIGHT_BLUE] = new Color(180, 180, 255);
		color[CM_LIGHT_YELLOW] = new Color(255, 255, 180);
		color[CM_LIGHT_ORANGE] = new Color(255, 200, 100);
		color[CM_LIGHT_CYAN] = new Color(180, 255, 255);
		color[CM_LIGHT_MAGENTA] = new Color(255, 180, 255);
		color[CM_GRAY] = new Color(180, 180, 180);
		color[CM_WHITE] = new Color(255, 255, 255);
		color[CM_DARK_TEXT] = new Color(0, 0, 0);
		color[CM_MEDIUM_TEXT] = new Color(100, 100, 100);
		color[CM_LIGHT_TEXT] = new Color(200, 200, 200);

		// Track Colors
		color[CM_TRACK_BG] = new Color(60, 65, 73);
		color[CM_TRACK_BG_ACTIVE] = new Color(190, 90, 90);
		color[CM_TRACK_PANEL_BG] = new Color(190, 205, 210);
		color[CM_TRACK_PANEL_BG_ACTIVE] = new Color(190, 140, 90);

		// CLIP COLORS
		color[CM_CLIP_BG] = new Color(205, 220, 210);
		color[CM_CLIP_BG_ACTIVE] = new Color(205, 220, 210);
		color[CM_CLIP_BG_SELECTED] = new Color(101, 111, 171);
		color[CM_CLIP_BG_MUTED] = new Color(40, 40, 40);
		color[CM_CLIP_INFO_AREA_BG] = new Color(199, 190, 218);
		color[CM_CLIP_INFO_AREA_BG_ACTIVE] = new Color(240, 190, 218);
		color[CM_CLIP_PEAK_MICROVIEW] = new Color(120, 40, 90);
		color[CM_CLIP_PEAK_MACROVIEW] = new Color(0, 100, 120);
		color[CM_CLIP_PEAK_OVERLOADED_SAMPLE] = new Color(255, 0, 0);

		// Curve/Filters Colors
		color[CM_CURVE_ACTIVE] = new Color(255, 50, 50);
		color[CM_CURVE_NONACTIVE] = new Color(110, 100, 130);
		color[CM_FILTERCONTROLLER_ACTIVE] = new Color(255, 50, 50);
		color[CM_FILTERCONTROLLER_NONACTIVE] = new Color(110, 100, 130);

		//BusMonitor Colors
		color[CM_BUS_BACKGROUND] = new Color(140, 160, 120);
		color[CM_BUS_BACKGROUND_ACTIVE] = new Color(240, 160, 120);
		color[CM_CARD_INFO_BACKGROUND] = new Color(50, 55, 61);
		color[CM_BUS_LEVEL_CLEAR_COLOR] = new Color(60, 70, 60);
		color[CM_BUS_BACKGROUND_GREYD_OUT] = new Color(120, 120, 120);
		color[CM_BUS_LEVEL_CLEAR_COLOR_GREYD_OUT] = new Color(90, 90, 90);
		}



	public static Color getCmColor(int colorIndex) //MIG Color get(int colorIndex)
		{
		if (blur[colorIndex])
			{
			Color x = null;
			Color c = color[colorIndex];
			int r = 0;//MIG c.red();
			int g = 0;//MIG c.green();
			int b = 0;//MIG c.blue();
			float fr = (float) r / 255;
			float fg = (float) g / 255;
			float fb = (float) b / 255;
			int dr = (int) (50 * fr);
			int dg = (int) (50 * fg);
			int db = (int) (50 * fb);
			r = 90 + dr;
			g = 90 + dg;
			b = 120 + db;
			//MIG x.setRgb(r,g,b);
			return x;
			}
		return color[colorIndex];
		}



	public static void setCmBlur(int index, boolean stat)
		{
		blur[index] = stat;
		}
	}
