package org.protux.core.gui;

import static org.protux.core.Debugger.*;

import java.awt.Component;
import java.io.File;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.protux.core.Debugger;
import org.protux.core.Protux;

public class Popup
	{
		public static void warn(String message)
			{
			JOptionPane.showMessageDialog(null,message);
			PWARN(message);
			}


		public static void error(String message)
			{
			PERROR(message);
			}


		public static void info(String message)
			{
			PMESG(Debugger.BASIC, message);
			}


		public static boolean confirm(String message)
			{
			return JOptionPane.showConfirmDialog(null, message) == 0;
			}


		public static File selectFile(String msg)
			{
			File file = null;
			JFileChooser f = new JFileChooser();
			f.setDialogTitle(msg);
			if (f.showOpenDialog(null) == JFileChooser.APPROVE_OPTION)
				file = f.getSelectedFile();
			return file;
			}


		public static File selectDir(String msg)
			{
			File file = null;
			JFileChooser f = new JFileChooser();
			f.setDialogTitle(msg);
			f.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			while ((file == null) || (!file.isDirectory()))
				{
				if (f.showOpenDialog(null) == JFileChooser.APPROVE_OPTION)
					file = f.getSelectedFile();
				}
			return file;
			}


		public static String getString(String msg, String initValue)
			{
			return JOptionPane.showInputDialog((Component) null,""+msg,initValue);
			}


	}
