package org.protux.core.gui;

import static org.protux.core.Debugger.PERROR;
import static org.protux.core.Debugger.PMESG;
import static org.protux.core.Debugger.PWARN;

import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Choice;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import org.protux.core.Const;
import org.protux.core.Factory;
import org.protux.core.GlobalProperties;
import org.protux.core.Project;
import org.protux.core.Protux;
import org.protux.core.editor.AudioSourceList;
import org.protux.core.editor.Song;
import org.protux.core.engines.audio.SimpleAudioPlayer;
import org.protux.core.engines.audio.SoftBusMapper;
import org.protux.core.media.audio.AudioMedia;

public class ProjectManager extends JFrame
	{
		private boolean created = false;
		private JFileChooser fileBrowser;
		JList list;
		DefaultListModel model;

		private int counter = 15;
		private static Project currentProject = null; // singleton
		private static ProjectManager manager = null;
		boolean isPlaying = false;
		JList audioListView;
		SimpleAudioPlayer map = null;
		Button btnFilePlay;
		Button btnSourcePlay;
		Button btnDeleteProject;
		Button btnRender;
		Button btnMaster;
		Button btnBurnCD;
		Button btnCreateProject;
		Button btnLoadProject;
		Button btnSaveProject;
		Button btnCopyToProject;
		Button btnSaveSong;
		Button btnRemoveSongFromProject;
		Button btnDeleteSong;
		Button btnSaveSongAs;
		Button btn;
		Button btnNewSong;
		Button btnDeleteSource;
		Button btnRemoveUnusedSources;
		Button btnRemoveAllAudioSources;
		Button btnExportSource;
		Button btnAddFileAsSource;
		Button btnImportFileNow;
		Button btnAddSourceCDA;
		Button btnImportNowCDA;
		Button btnCDAPlay;
		// MIG map;
		TextField fieldFileDestTrack;
		TextField fieldFileDestPos;
		TextField fieldDestSongCDA;
		TextField fieldDestTrackCDA;
		TextField fieldDestPosCDA;
		TextField fieldAlbumTitle;
		TextField fieldNOfSongs;
		TextField fieldEngineer;
		TextField fieldSaveProjAs;
		TextField fieldMasterGain;
		TextField fieldNumTracks;
		TextField fieldFileDestSong;
		TextField fieldArtists;
		TextField fieldCopyTo;
		TextField fieldAudioSourceInfo;
		TextField fieldFileInfo;
		TextField fieldSongDur;
		Label lblAlbumTitle;
		Label lblNOfSongs;
		Label lblStatus;
		Label lblTotalDur;
		Label lblEngineer;
		Label lblMasterGain;
		Label lblNumTracks;
		Label lblSongDur;
		Label lblArtist;
		Label TextLabel2;
		Label lblOr;
		Label lblSourceSpectro;
		Label lblDSPVol1;
		Label volumeSource;
		Label lblDSPVol2;
		Label volumeFile;
		Label lblFileBrowser_2;
		Label lblFileSpectro;
		Label lblFileDestSong;
		Label lblFileDestTrack;
		Label lblFileDestPos;
		Label lblCDBrowser_2;
		Label lblDestSongCDA;
		Label lblDestTrackCDA;
		Label lblDestPosCDA;
		Label lblCDAVol;
		Choice cmbStatus;
		Choice cmbSongStatus;
		Choice cmbPreListenBus;


		/*
		 * QTabWidget* mainTabPane; QListView* listAlbumProjects; QListView* listSongs; QSlider* sliderSource; QSlider* sliderCDA; QSlider* sliderFile; QCheckBox* checkFileInfo; QCheckBox* checkFileSpectro; QCheckBox* checkSourceInfo; QCheckBox* checkSourceSpectro; QCheckBox* checkFakeImportCDA; QCheckBox* checkFileFakeImport; QGroupBox*
		 * grpImportCDA; QGroupBox* grpPreListenSource; QGroupBox* grpPreListenFile; QGroupBox* grpPreListenCDA; QGroupBox* grpImportFile; QProgressBar* pbarImportCDA; QProgressBar* pbarFileImport;
		 */

		public static ProjectManager createManager()
			{
			if (manager == null)
				manager = new ProjectManager();
			return manager;
			}


		protected ProjectManager()
			{
			super("Project Manager");
			manager = this;
			setLayout(new BorderLayout());
			model = new DefaultListModel();
			list = new JList(model);
			JScrollPane scroll = new JScrollPane(list);
			JPanel bottonPanel = new JPanel();
			bottonPanel.setLayout(new GridLayout(1, 2));
			JButton buttonOpenProject = new JButton("Open");
			JButton buttonRemoveProject = new JButton("Remove");
			buttonRemoveProject.setEnabled(false);
			JButton buttonCreateProject = new JButton("Create");
			bottonPanel.add(buttonOpenProject);
			bottonPanel.add(buttonRemoveProject);
			bottonPanel.add(buttonCreateProject);

			buttonOpenProject.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
						{
						openSelectedProject();
						}

				});

			buttonRemoveProject.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
						{
						}
				});
			buttonCreateProject.addActionListener(new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
						{
						createNewProject();
						}
				});

			add(scroll, BorderLayout.CENTER);
			add(bottonPanel, BorderLayout.SOUTH);
			setSize(320, 400);
			}


		private void refreshProjects()
			{
			model.clear();
			File pbd = new File(GlobalProperties.getProjectsBaseDir());
			File[] lf = pbd.listFiles();
			int np = lf.length;
			for (int i = 0; i < np; i++)
				{
				File f = lf[i];
				model.addElement(f.getName());
				}
			}


		public void createNewProject()
			{
			String projName = Popup.getString("Enter projects name", "New Project");
			try
				{
				createNewProject(projName, Const.DEFAULT_NUM_SONGS);
				GlobalProperties.setLastProjectName(projName);
				Protux.info("Project sucessfully created");
				}
			catch (Exception ex)
				{
				error("createNewProject", "" + ex);
				Popup.error("Cannot create project " + projName);
				}
			}


		public void createNewProject(String projectName, int numSongs) throws Exception
			{
			if ((currentProject != null) && (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED))
				{
				throw new Exception("current song is not stopped");
				}
			if (projectExists(projectName))
				{
				throw new Exception("Project " + projectName + " already exists ");
				}
			Project newProject = Factory.createProject(projectName, numSongs);
			setCurrentProject(newProject);
			}


		public static Project getCurrentProject()
			{
			return currentProject;
			}


		public void setCurrentProject(Project pProject)
			{
			if ((currentProject != null) && (currentProject.changed()))
				{
				try
					{
					currentProject.save();
					}
				catch (IOException ex)
					{
					error("setCurrentProject", "" + ex);
					}
				}
			currentProject = pProject;
			GlobalProperties.setLastProjectName(currentProject.getTitle());
			}


		private void error(String where, String what)
			{
			PERROR("[ Project Manager ] - " + where + "()", what);
			}


		public boolean createSongInCurrentProject(String title, String artists, int numTracks)
			{
			if (currentProject == null)
				{
				return false;
				}
			Song s = currentProject.createSong(GlobalProperties.getInt("DEFAULT_SAMPLE_RATE"), GlobalProperties.getInt("DEFAULT_BIT_DEPTH"));
			if (s != null)
				{
				currentProject.addSong(s);
				return true;
				}
			return false;
			}


		// METHODS TO BE REVIEWED -----------------------------------------------------------------
		// //delete file/dir pName after prepending $HOME/protuxprojects/ to it
		//
		// if it is a directory, calls itself recursively on any file/dir in the directory
		// before removing the directory
		int remove_recursively(String projectName)
			{
			String projectDir = GlobalProperties.getProjectsBaseDir() + "/" + projectName;
			// check if we are removing the currentProject, and //delete it before removing its files
			if (project_is_current(projectName))
				{
				if (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED)
					{
					PERROR("current song is not stopped");
					return -1;
					}
				PMESG(3, "removing current project");
				currentProject = null;
				}
			File fileInfo = new File(projectDir);
			if (!fileInfo.exists())
				{
				return -1;
				}
			if (!fileInfo.canWrite())
				{
				PERROR("failed to remove " + projectDir + ": you don't have write access to it");
				return -1;
				}
			if (fileInfo.isFile())
				{
				File file = new File(projectDir);
				if (!file.delete())
					{
					PERROR("failed to remove file " + projectDir);
					return -1;
					}
				return 1;
				}
			else if (fileInfo.isDirectory())
				{
				File dir = new File(projectDir);
				/*
				 * MIG const QFileInfoList *files = dir.entryInfoList(); if (files) { QFileInfoListIterator it( *files); File *fi; while ((fi = it.current()) != 0) { String filename(fi.fileName()); if ((filename != ".") && (filename != "..")) { remove_recursively(pName + "/" + filename); } ++it; } }
				 */
				if (!dir.renameTo(new File(projectDir)))
					{
					PERROR("failed to remove directory " + projectDir);
					return -1;
					}
				return 1;
				}
			return 1;
			}


		int copy_recursively(String pNameFrom, String pNameTo)
			{
			if ((currentProject != null) && (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED))
				{
				PERROR("current song is not stopped");
				return -1;
				}
			String nameFrom = "";// MIG (getenv("HOME"));
			String nameTo = nameFrom;
			nameFrom = nameFrom + "/protuxprojects/" + pNameFrom;
			nameTo = nameTo + "/protuxprojects/" + pNameTo;
			File fileFromInfo = new File(nameFrom);
			File fileToInfo = new File(nameTo);
			if (!fileFromInfo.exists())
				{
				PERROR("File or directory %s doesn't exist " + pNameFrom);
				return -1;
				}
			if (fileToInfo.exists())
				{
				PERROR("File or directory %s already exists " + pNameTo);
				return -1;
				}
			if (fileFromInfo.isFile())
				{
				File fileFrom = new File(nameFrom);
				if (false) // MIG !fileFrom.open(IO_ReadOnly))
					{
					PERROR("failed to open file %s for reading " + nameFrom);
					return -1;
					}
				File fileTo = new File(nameTo);
				if (false)// MIG !fileTo.open(IO_WriteOnly))
					{
					// MIG fileFrom.close();
					PERROR("failed to open file for writting" + nameFrom);
					return -1;
					}
				// the real copy part should perhaps be implemented using QDataStream
				// but .handle() will still be needed to get the optimal block-size
				//
				// ! \todo does not keep file mode yet
				int bufferSize = 4096;
				/*
				 * MIG int fileDescFrom = fileFrom.handle(); int fileDescTo = fileTo.handle(); struct stat fileStat; if (fstat(fileDescFrom, &fileStat) == 0) bufferSize = (int)fileStat.st_blksize; void *buffer = malloc(sizeof(char) * bufferSize); // QMemArray<char> buffer(bufferSize); for (;;) { int nRead = read(fileDescFrom, buffer, bufferSize);
				 * if (nRead < 0) { fileFrom.close(); fileTo.close(); PERROR("Error while reading file " + nameFrom); return -1; } if (nRead == 0) break; if (write(fileDescTo, buffer, nRead) < 0) { fileFrom.close(); fileTo.close(); PERROR("Error while writing file " + nameTo); return -1; } } free(buffer);
				 */
				// MIG fileFrom.close();
				// MIG fileTo.close();
				return 0;
				}
			else if (fileFromInfo.isDirectory())
				{
				File dirFrom = new File(nameFrom);
				File dirTo = new File(nameTo);
				if (!dirTo.mkdir())
					{
					PERROR("failed to create directory " + nameTo);
					return -1;
					}
				List files = null;// MIG dirFrom.entryInfoList();
				if (files != null)
					{
					/*
					 * MIG QFileInfoListIterator it( *files); File *fi; while ((fi = it.current()) != 0) { String filename(fi.fileName()); if ((filename != ".") && (filename != "..")) { copy_recursively(pNameFrom + "/" + filename, pNameTo + "/" + filename); } ++it; }
					 */
					}
				return 0;
				}
			return -1;
			}


		private void saveSong(String songName) throws IOException
			{
			Song s = null;
			if (songName.equals(""))
				{
				s = currentProject.get_current_song();
				songName += s.id;
				songName = "Song " + songName;
				}
			else
				{
				// assuming that song name is always: "Song nr title" so nr is always on position 5-7
				String t = songName.substring(5, 7);
				int nr = Integer.parseInt(t);
				s = currentProject.get_song((nr - 1));
				}
			if (s != null)
				{
				s.save();
				}
			}


		public void saveSongAs(String songName, String title, String artists) throws IOException
			{
			Song s;
			String t = songName.substring(5, 7);
			boolean b;
			// assuming that song name is always: "Song nr title" so nr is always on position 5-7
			int nr = 0;// MIG t.toInt(&b, 10);
			s = currentProject.get_song((nr - 1));
			s = currentProject.get_song((nr - 1));
			if (title.length() != 0)
				{
				s.setTitle(title);
				}
			if (artists.length() != 0)
				{
				s.setArtists(artists);
				}
			s.save();
			}


		public int delete_source(String sourceName)
			{
			int r = 0;
			String s = currentProject.getRootDir() + sourceName;
			Song cs = currentProject.get_current_song();
			AudioMedia a = cs.audioSourcesList.get_audio_for_source(s);
			cs.removeAllClipsForAudio(a);
			cs.audioSourcesList.remove(a);
			// delete a;
			File file = new File(s);
			if (!file.delete())
				{
				PERROR("failed to remove file " + s);
				r = -1;
				}
			String peakFile = s + ".peak";
			file = new File(peakFile);
			if (!file.delete())
				{
				PERROR("failed to remove file " + peakFile);
				r = -1;
				}
			// MIG dialog.update_audio_sources_list();
			cs.recreateEditor();
			return 1;
			}


		public Project loadProject(String projectName) throws IOException
			{
			if ((currentProject != null) && (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED))
				{
				PERROR("current song is not stopped");
				return null;
				}
			if (!projectExists(projectName))
				{
				throw new IOException("Project " + projectName + " does not exist");
				}
			Project newProject = new Project(projectName);
			newProject.load();
			setCurrentProject(newProject);
			return newProject;
			}


		public boolean project_is_current(String title)
			{
			String path = "";// MIG (getenv("HOME"));
			path = path + "/protuxprojects/" + title;
			if ((currentProject != null) && (currentProject.getRootDir().equals(path)))
				{
				return true;
				}
			return false;
			}


		public boolean projectExists(String title)
			{
			String pd = GlobalProperties.getProjectsBaseDir();
			return new File(pd + "/" + title).exists();
			}


		/*
		 * JmbSlot save_project(JmbMessage* m) { if (currentProject!=null) currentProject.save(); else parentInterface.info("OPEN OR CREATE A PROJECT FIRST!!"); return (MustuxAction*) 0; } JmbSlot render_song(JmbMessage* m) { if (currentProject!=null) currentProject.get_current_song().render(); else parentInterface.info("OPEN OR CREATE A PROJECT
		 * FIRST!!"); return (MustuxAction*) 0; } JmbSlot use_song(JmbMessage* m) { if (currentProject!=null) { currentProject.set_current_song(m.collectedNumber - 1); parentInterface.info("USING SONG " + "" + m.collectedNumber); } else parentInterface.info("OPEN OR CREATE A PROJECT FIRST!!"); return (MustuxAction*) 0; } JmbSlot
		 * toggle_snap(JmbMessage* m) { parentInterface.info("TOGGLE SNAP ON/OFF"); if (currentProject!=null) { Song so = currentProject.get_current_song(); if (so) so.toggle_snap(); } parentInterface.update_system_resources(); return (MustuxAction*) 0; }
		 */
		public void update()
			{
			if (created)
				{
				if (currentProject != null)
					{
					btnMaster.setEnabled(true);
					btnSaveProject.setEnabled(true);
					fieldAlbumTitle.setText(currentProject.getTitle());
					String sNOfSongs = "" + currentProject.getNumSongs();
					fieldNOfSongs.setText(sNOfSongs);
					fieldEngineer.setText(currentProject.getEngineer());
					}
				else
					{
					btnMaster.setEnabled(false);
					btnSaveProject.setEnabled(false);
					}
				update_audio_sources_list();
				update_projects_list();
				update_song_list();
				}
			}


		public void update_audio_sources_list()
			{
			if (currentProject == null)
				{
				return;
				}
			Song s = currentProject.get_current_song();
			if (s == null)
				{
				return;
				}
			AudioSourceList asl = s.audioSourcesList;
			int tot = asl.get_total_sources();
			// MIG audioListView.clear();
			for (int i = 0; i < tot; i++)
				{
				AudioMedia audio = asl.get_source_for_index(i);
				if (audio == null)
					{
					continue;
					}
				String sFile = ""; // MIG a.media.phisicalFile;
				int ln = sFile.length();
				String pTitle = currentProject.getTitle();
				int skip = sFile.indexOf(pTitle);
				ln -= (skip + pTitle.length());
				// MIG sFile = sFile.right(ln);
				String sType;
				if (sFile.indexOf("wav") >= 0)
					{
					sType = "WAV";
					}
				else
					{
					sType = "PRAF";
					}
				String sRate = "" + audio.rate;
				String sBitDepth = "" + audio.bitDepth;
				String sChannels = (audio.channels == 1 ? "MONO" : "STEREO");
				String sLenght = "" + audio.totalBlocks;
				// mig String sSize = "" + audio.fileSize;
				String sClips = "" + audio.get_clips_count();
				/*
				 * Object it = new QListViewItem(audioListView); it.setText(0, sFile); it.setText(1, sType); it.setText(2, sLenght); it.setText(3, sSize); it.setText(4, sClips); it.setText(5, "0"); it.setText(6, sRate); it.setText(7, sChannels); it.setText(8, sBitDepth);
				 */
				}
			}


		public void update_projects_list()
			{
			// MIG listAlbumProjects.clear();
			String projsDir = ""; // MIG //(getenv("HOME"));
			projsDir = ""; // MIG + "/protuxprojects/";
			File pDir = new File(projsDir);
			/*
			 * MIG QFileInfoList* files = pDir.entryInfoList(); if ( files ) { QFileInfoListIterator it( *files ); QFileInfo* fi; while( (fi=it.current()) != 0 ) { ++it; if ( (fi.fileName() != ".") && (fi.fileName() != "..") ) { String sNumSongs; String engineer; String title = "Hey! Me here?"; QFile f(projsDir+fi.fileName()+"/project.properties");
			 * if ( f.open(IO_ReadOnly) ) { QTextStream stream( &f ); while (!stream.eof()) { String line = stream.readLine(); line = line.stripWhiteSpace(); if (line.indexOf("title=")>=0) title=line.mid(line.indexOf("title=")+6); if (line.indexOf("numSongs=")>=0) sNumSongs=line.mid(line.indexOf("numSongs=")+9); if (line.indexOf("engineer=")>=0)
			 * engineer=line.mid(line.indexOf("engineer=")+9); } } String status; if ((currentProject!=null) && (currentProject.title == title)) status = currentProject.has_changed()?"Unsaved":"Saved"; else status="Saved"; f.close(); Object it = new QListViewItem( listAlbumProjects); it.setText(0,title); it.setText(1,sNumSongs);
			 * it.setText(3,status); } } } if (currentProject!=null) fieldAlbumTitle.setText( currentProject.title );
			 */
			}


		public void update_song_list()
			{
			if (currentProject == null)
				{
				return;
				}
			int numSongs = currentProject.getNumSongs();
			// MIG listSongs.clear();
			for (int i = 0; i < numSongs; i++)
				{
				Song s = currentProject.get_song(i);
				if (s == null)
					{
					continue;
					}
				String songNr = "" + i;
				if (i < 10)
					{
					songNr = "0" + songNr;
					}
				String songName = "Song " + songNr + " - ";
				songName += s.title;
				String numberOfTracks = "" + s.getNumTracks();
				int rate = s.rate;
				long bpos = s.lastBlock;
				if (bpos < 0)
					bpos = 0;
				float f = rate / 30;
				float flo = (float) bpos / f;
				long framepos = (long) flo;
				int pfr = (int) framepos % 30;
				int pho = (int) (framepos / 108000) % 60;
				int pmi = (int) (framepos / 1800) % 60;
				int pse = (int) (framepos / 30) % 60;
				if (pho < 0)
					pho = 0;
				if (pmi < 0)
					pmi = 0;
				if (pse < 0)
					pse = 0;
				if (pfr < 0)
					pfr = 0;
				String spho = "" + pho;
				String spmi = "" + pmi;
				if (pmi < 10)
					{
					spmi = 0 + spmi;
					}
				String spse = "" + pse;
				if (pse < 10)
					{
					spse = "0" + spse;
					}
				String spfr = "" + pfr;
				if (pfr < 10)
					{
					spfr = "0" + spfr;
					}
				String songLength = spho + ":" + spmi + ":" + spse + "," + spfr;
				// String songLength; songLength.setNum( spos );
				String songRate = "" + rate;
				String songBitDepth = "" + s.bitDepth;
				String songStatus = s.isChanged ? "UnSaved" : "Saved";
				String songSpaceAllocated = "Unknown";
				/*
				 * for later: String sLenght; sLenght.setNum((double)a.file.totalBlocks,'f',0); String sSize; sSize.setNum((double)a.file.fileSize,'f',0);
				 */
				/*
				 * Object it = new QListViewItem(listSongs); it.setText(0, songName); it.setText(1, numberOfTracks); it.setText(2, songLength); it.setText(3, songRate); it.setText(4, songBitDepth); it.setText(5, songStatus); it.setText(6, songSpaceAllocated);
				 */
				}
			}


		// ------------------------------- xxx_clicked()
		public void tab_changed()
			{
			/*
			 * MIG if (mainTabPane.currentPageIndex()==2) { update_audio_sources_list(); } if (mainTabPane.currentPageIndex()==1) { update_song_list(); }
			 */
			}


		void listAlbumProject_projectSelected()
			{
			Object item = null;
			item = null;// MIG listAlbumProjects.currentItem();
			if (item != null)
				{
				// MIG fieldSaveProjAs.setText(item.text(0));
				}
			}


		public void btnCreateProject_clicked()
			{
			// is current song stopped ?
			if ((currentProject != null) && (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED))
				{
				// MIG Popup.warn(this,"Protux - Warning","This operation is not permitted while a song is playing,\nrecording, or some tracks are armed");;
				return;
				}
			// do we have the name of the project to create ?
			String title;
			title = fieldSaveProjAs.getText();
			if (title.length() == 0)
				{
				// MIG Popup.warn(this,"Protux - Warning","You must supply a name for the project");;
				return;
				}
			// ask if the current project should first be saved (only when status is "UnSaved")
			if (((currentProject != null) && currentProject.has_changed()) && (Popup.confirm("Should the current project first be saved ?")))
				{
				try
					{
					currentProject.save();
					}
				catch (IOException ex)
					{
					System.out.println("Error : " + ex);
					}
				}
			// first test if project exists already
			if (projectExists(title))
				{
				if (Popup.confirm("The project \"" + title + "\" already exists, do you want to remove it and replace it with a new one ?"))
					{
					remove_recursively(title);
					}
				}
			String sNumSongs = fieldNOfSongs.getText();
			int numSongs = 0;
			try
				{
				numSongs = Integer.parseInt(sNumSongs);
				}
			// When input is not a decimal number, set it to a sane default value
			catch (Exception ex)
				{
				numSongs = 2;
				}
			try
				{
				createNewProject(title, numSongs);
				}
			catch (Exception ex)
				{
				error("btnCreateProject_clicked", "" + ex);
				Popup.warn("Couldn't create project \"" + title + "\"");
				}
			update_projects_list();
			}


		public void btnImportNow_clicked()
			{
			if (btnImportFileNow.getLabel().equals("Import now!"))
				{
				if (currentProject != null)
					{
					btnImportFileNow.setLabel("Cancel import!");
					// MIG qApp.processEvents(); //please remove me, but I'm used when importing mp3 files, which I (btnImportFileNow) can't abort :-(
					if (false) // MIG currentProject.import_audio(fileBrowser.pathCombo.currentText(), pbarFileImport))
						{
						// some error message?
						}
					btnImportFileNow.setLabel("Import now!");
					}
				}
			else
				{
				// FIXME / WAS / FORLATER currentProject.get_current_song().cancel_import_audio();
				btnImportFileNow.setLabel("Import now!");
				// MIG pbarFileImport.reset();
				}
			}


		public void btnSaveProject_clicked()
			{
			// is current song stopped ?
			if ((currentProject != null) && (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED))
				{
				Popup.warn("This operation is not permitted while a song is playing,\nrecording, or some tracks are armed");
				return;
				}
			if (currentProject != null)
				{
				currentProject.setTitle(fieldAlbumTitle.getText());
				currentProject.setEngineer(fieldEngineer.getText());
				try
					{
					currentProject.save();
					}
				catch (IOException ex)
					{
					System.out.println("Error : " + ex);
					}
				Popup.warn("Project \"" + currentProject.getTitle() + "\" saved.");
				}
			update_projects_list();
			}


		public void btnLoadProject_clicked()
			{
			// is current song stopped ?
			if ((currentProject != null) && (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED))
				{
				Popup.warn("This operation is not permitted while a song is playing,\nrecording, or some tracks are armed");
				return;
				}
			// do we have the name of the project to load ?
			String title;
			title = fieldSaveProjAs.getText();
			if (title.length() == 0)
				{
				Popup.warn("You must supply a name for the project");
				return;
				}
			// ask if the current project should first be saved
			if ((currentProject != null) && (currentProject.has_changed()))
				if (Popup.confirm("Should the current project first be saved ?"))
					{
					try
						{
						currentProject.save();
						}
					catch (IOException ex)
						{
						System.out.println("Error : " + ex);
						}
					}
			// first test if project exists
			if (!projectExists(title))
				{
				Popup.warn("The project \"" + title + "\" doesn't exist");
				update_projects_list();
				return;
				}
			try
				{
				loadProject(title);
				}
			catch (IOException ex)
				{
				PERROR("Could not load project " + title + " : " + ex);
				}
			}


		public void btnCopyToProject_clicked()
			{
			// is current song stopped ?
			if ((currentProject != null) && (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED))
				{
				Popup.warn("This operation is not permitted while a song is playing,\nrecording, or some tracks are armed");
				return;
				}
			// do we have the name of the project to create ?
			if (currentProject == null)
				{
				Popup.warn("There is no Project to save!");
				return;
				}
			String projectTo;
			projectTo = fieldSaveProjAs.getText();
			if (projectTo.length() == 0)
				{
				Popup.warn("You must supply a name for the project");
				return;
				}
			// the current project should first be saved
			// ! \todo only ask if project has not been saved
			if ((currentProject != null) && (Popup.confirm("The current project has first to be saved before you can copy it !\nFuture versions will hopefully get rid of this constraint.")))
				{
				try
					{
					currentProject.save();
					}
				catch (IOException ex)
					{
					System.out.println("Error : " + ex);
					}
				}
			// first test if project exists already
			if ((projectExists(projectTo)) && (Popup.confirm("The project \"" + projectTo + "\" already exists, do you want to remove it and replace it with the current one ?")))
				{
				remove_recursively(projectTo);
				}
			String projectFrom = currentProject.getRootDir();
			// projectFrom = projectFrom.section("/", -1); // was not compatible with Qt 2.3, replaced with following 2 lines
			int index = 0;// MIG projectFrom.findRev("/", -1);
			projectFrom = projectFrom.substring(0, index + 1);
			copy_recursively(projectFrom, projectTo);
			update_projects_list();
			try
				{
				loadProject(projectTo);
				}
			catch (IOException ex)
				{
				System.out.println("Error : " + ex);
				}
			}


		public void btnDeleteProject_clicked()
			{
			// do we have the name of the project to delete ?
			String title;
			title = fieldSaveProjAs.getText();
			if (title.length() == 0)
				{
				Popup.warn("You must supply a name for the project");
				return;
				}
			// if deleting current project, is current song stopped ?
			if ((project_is_current(title)) && currentProject != null && (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED))
				{
				Popup.warn("This operation is not permitted while a song is playing,\nrecording, or some tracks are armed");
				return;
				}
			// first test if project exists
			if (!projectExists(title))
				{
				Popup.error("The project \"" + title + "\" doesn't exist");
				update_projects_list();
				return;
				}
			if (Popup.confirm("Are you sure that you want to remove the project \"" + title + "\" ? It's not possible to undo it !"))
				{
				remove_recursively(title);
				update_projects_list();
				// The ProjectArea in Interface is now empty, set the dummyWidget to make it look less worse ;-)
				// MIG parentInterface.setCurrentProject( (Project) parentInterface.dummyWidget);
				}
			}


		public void listSongs_songSelected()
			{
			// MIG Object objitem = null;
			// MIG item = listSongs.currentItem();
			// MIG if (item == null)
			// MIG {
			// MIG return;
			// MIG }
			Song s;
			String title;
			String artists;
			title = "";// MIG item.text(0);
			int length = title.length();
			length -= 10;
			// find the selected Song
			String t = title.substring(5, 7);
			int nr = Integer.parseInt(t);
			s = currentProject.get_song((nr - 1));
			artists = s.artists;
			// MIG title = title.right(length);
			fieldCopyTo.setText(title);
			fieldArtists.setText(artists);
			}


		public void btnSaveSong_clicked()
			{
			if (currentProject == null)
				{
				return;
				}
			// MIG Object it = listSongs.selectedItem();
			String name = "";
			if (false) // it != null)
				{
				name = "";// MIG it.text(0);
				try
					{
					saveSong(name);
					}
				catch (IOException ex)
					{
					System.out.println("Error : " + ex);
					}
				}
			else
				{
				try
					{
					saveSong(name);
					Popup.info("Song " + name + "Succesfully saved!");
					}
				catch (IOException ex)
					{
					System.out.println("Error : " + ex);
					Popup.info("Failed to save " + name);
					}
				}
			update_song_list();
			}


		public void btnSaveSongAs_clicked()
			{
			if (currentProject == null)
				{
				return;
				}
			// MIG Object it = listSongs.selectedItem();
			String name;
			String title;
			String artists;
				// MIG if (it != null)
				{
				name = null;// MIG it.text(0);
				title = fieldCopyTo.getText();
				artists = fieldArtists.getText();
				try
					{
					saveSongAs(name, title, artists);
					}
				catch (IOException ex)
					{
					System.out.println("Error : " + ex);
					}
				catch (Exception ex)
					{
					Popup.warn("Failed to rename and save " + name);
					}
				}
			update_song_list();
			}


		public void btnSaveSongCopyAs_clicked()
			{
			Popup.warn("No tip for this lack.. sorry :-}");
			}


		public void btnNewSong_clicked()
			{
			if (createSongInCurrentProject("", "", 6))
				{
				PMESG(3, "song added");
				update_song_list();
				}
			}


		public void btnRemoveSongFromProject_clicked()
			{
			Popup.warn("No tip for this lack.. sorry :-}");
			}


		public void btnDeleteSong_clicked()
			{
			// MIG Object objitem = null;
			int r = 0;
			int nr = 0;
			Song s;
			// MIG item = listSongs.currentItem();
			// MIG if (item != null)
			// MIG{
			String title = "";
			// MIG title = item.text(0);
			int length = title.length();
			length -= 10;
			String t = title.substring(5, 7);
			boolean b;
			// MIG nr = t.toInt(&b, 10);
			t = "" + nr;
			t = currentProject.getTitle() + "/song_" + t;
			r = remove_recursively(t);
			// MIG }
			// MIG if (r != null)
			// MIG {
			for (int i = 0 /* MIG nr */; i <= currentProject.getNumSongs(); i++)
				{
				s = currentProject.get_song(i);
				if (s != null)
					{
					s.id--;
					String dirname = "/song_" + s.id;
					r = s.rename_dir(dirname);
					if (r < 0)
						{
						PERROR("Failed to rename Song directory");
						}
					}
				}
			currentProject.remove_song(nr - 1);
			try
				{
				currentProject.saveProperties();
				}
			catch (IOException ex)
				{
				System.out.println("Error : " + ex);
				}
			update_song_list();
			// MIG }
			}


		public void btnDeleteSource_clicked()
			{
				// Remove current selected audio source in audioListView;
				// MIG Object it = audioListView.selectedItem();
				// MIG if (it == null)
				{
				// MIG return;
				}
			String s = "";// MIG it.text(0);
			int r = delete_source(s);
			if (r > 0)
				{
				PMESG(3, "File " + s + " removed succesfully ");
				}
			}


		public void btnRemoveUnusedSources_clicked()
			{
			if (currentProject == null)
				{
				return;
				}
			int numberRemovedSources = 0;
			int numSongs = currentProject.getNumSongs();
			for (int i = 0; i < numSongs; i++)
				{
				Song s = currentProject.get_song(i);
				AudioSourceList asl = s.audioSourcesList;
				int tot = asl.get_total_sources();
				for (int i1 = tot - 1; i >= 0; --i)
					{
					AudioMedia a = asl.get_source_for_index(i1);
					if (a == null) // No audio source for this index, strange....
						{
						PWARN("No audioSource for this index in AudioSourceList!");
						continue;
						}
					String aName = ""; // MIG a.media.phisicalFile;
					if (s.getClipsCountForAudio(a) == 0)
						{
						if (asl.remove(a) < 0)
							{
							PWARN("Could not remove audioSource from AudioSourceList!");
							}
						File file = new File(aName);
						if (!file.delete())
							{
							PERROR("failed to remove file " + aName);
							}
						String peakFile = aName + ".peak";
						file = new File(peakFile);
						if (!file.delete())
							{
							PERROR("failed to remove file " + peakFile);
							}
						numberRemovedSources++;
						}
					}
				}
			if (numberRemovedSources == 0)
				{
				return;
				}
			update_audio_sources_list();
			String nrs = "" + numberRemovedSources;
			Popup.info("Removed " + nrs + " unused Sources!");
			}


		void btnRemoveAllAudioSources_clicked()
			{
			// MIG udioListView.selectAll(true); //Hmm, maybe not the best way, but it works ;-)
			if (false)// MIG !audioListView.selectedItem()) //nothing to remove at all...
				{
				return;
				}
			if (Popup.confirm("This action irreversibly deletes ALL current Song \n          Audio Sources from your hard disk. \n Are you sure ?"))
				{
				}
			while (audioListView.getSelectedValue() != null)
				{
				// MIG delete_source(audioListView.selectedItem().text(0));
				// MIG audioListView.selectAll(true);
				}
			}


		void btnExportSource_clicked()
			{
			Popup.warn("Try to convert the audio source manually with genpraf, ogg123, mpg123, notlame, or some other console tool");
			}


		public void create_audio_preview_player()
			{
			map = new SimpleAudioPlayer();
			String s = GlobalProperties.get("USE_PLUGHW");
			if (s == "YES")
				{
				map.set_use_plughw(true);
				}
			else
				{
				map.set_use_plughw(false);
				}
			}


		void btnSourcePlay_clicked()
			{
			if ((currentProject != null) && (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED))
				{
				PERROR("Current song is not stopped");
				return;
				}
			if (btnSourcePlay.getLabel() == "Play")
				{
				if (map == null)
					{
					create_audio_preview_player();
					}
				String desc = "";// MIG cmbPreListenBus.currentText();
				if (desc == "AUTO")
					desc = "";
				String fileName = "";
				Object it = null;// MIG audioListView.selectedItem();
				if (it != null)
					{
					fileName = currentProject.getRootDir() + ""; // MIG it.text(0);
					}
				map.set_source_file(fileName);
				map.set_bus_out_descriptor(desc);
				if (map.start() > 0)
					btnSourcePlay.setLabel("Stop");
				}
			else
				{
				if ((map != null) && (map.stop() > 0))
					{
					btnSourcePlay.setLabel("Play");
					}
				}
			}


		void sliderFile_moved()
			{
			float gain = 0.0f;// MIG (float) sliderFile.value() / 3.0f;
			// MIG sliderSource.setValue(sliderFile.value());
			if (map != null)
				{
				map.set_gain(gain);
				}
			}


		void sliderSource_moved()
			{
			float gain = 0.0f;// MIG (float) sliderSource.value() / 3.0f;
			// MIG sliderFile.setValue(sliderSource.value());
			if (map != null)
				{
				map.set_gain(gain);
				}
			}


		void btnFilePlay_clicked()
			{
			if ((currentProject != null) && (currentProject.get_current_song().softMapper.status != SoftBusMapper.STOPPED))
				{
				PERROR("Current song is not stopped");
				return;
				}
			if (btnFilePlay.getLabel().equals("Play"))
				{
				if (map == null)
					{
					create_audio_preview_player();
					}
				String desc = "";// MIG cmbPreListenBus.currentText();
				if (desc == "AUTO")
					desc = "";
				String fileName = "";
				fileName = "";// MIG fileBrowser.pathCombo.currentText();
				map.set_source_file(fileName);
				map.set_bus_out_descriptor(desc);
				if (map.start() > 0)
					{
					btnFilePlay.setLabel("Stop");
					}
				}
			else
				{
				if ((map != null) && (map.stop() > 0))
					{
					btnFilePlay.setLabel("Play");
					}
				}
			}


		void btnAddFileAsSource_clicked()
			{
			Popup.warn("ADD AS AUDIO SOURCE : Import it normally then it will become an audio source");
			}


		void btnAddSourceCDA_clicked()
			{
			Popup.warn("Import CDA track as audio source : Use \"cdda2wav -D/dev/cdrom -tX\" in\na console to import it (Note: X is the number of the track)");
			}


		void btnImportNowCDA_clicked()
			{
			Popup.warn("Import CDA track as audio source : Use \"cdda2wav -D/dev/cdrom -tX\" in\na console to import it (Note: X is the number of the track)");
			}


		void btnCDAPlay_clicked()
			{
			Popup.warn("CD PLAYER : Use the KDE or the Gnome CD player");
			}


		void btnRender_clicked()
			{
			Popup.warn("FULL PROJECT RENDER : You can render each song a time by <<ENTER>> in them");
			}


		void btnMaster_clicked()
			{
			Popup.warn("MASTER PROJECT : This is feature for a very distant future release.");
			}


		void btnBurnCD_clicked()
			{
			Popup.warn("BURN CD : We suggest k3b to burning CDs");
			}


		void audioListView_itemRenamed(Object obj)
			{
			}


		void audioListView_spacePressed(Object obj)
			{
			}


		void audioListView_returnPressed(Object obj)
			{
			}


		void audioListView_onItem(Object obj)
			{
			}


		void audioListView_collapsed(Object obj)
			{
			}


		void audioListView_expanded(Object obj)
			{
			}


		int create_dialog()
			{
			/*
			 * resize( 780, 500 ); setMaximumSize( QSize( 1024, 768 ) ); setCaption( "<PM> Project Manager" ); QFont f( "Helvetica", 12 ); setFont( f ); mainTabPane = new QTabWidget( this ); mainTabPane.setGeometry( QRect( 0, 0, 780, 500 ) ); connect( mainTabPane, SIGNAL( currentChanged(QWidget*) ), this, SLOT(tab_changed())); // Album Project tab
			 * ------------------------------------------------- tab = new QWidget( mainTabPane); QWidget* privateLayoutWidget = new QWidget( tab ); privateLayoutWidget.setGeometry( QRect( 10, 300, 710, 24 ) ); QHBoxLayout* hlayout1 = new QHBoxLayout( privateLayoutWidget, 0, 6); lblAlbumTitle = new QLabel( privateLayoutWidget);
			 * lblAlbumTitle.setMinimumSize( QSize( 65, 0 ) ); lblAlbumTitle.setText( tr( "CURRENT PROJECT : Title" ) ); hlayout1.addWidget( lblAlbumTitle ); fieldAlbumTitle = new QLineEdit( privateLayoutWidget); fieldAlbumTitle.setText( tr( "" ) ); hlayout1.addWidget( fieldAlbumTitle ); QWidget* privateLayoutWidget_2 = new QWidget( tab);
			 * privateLayoutWidget_2.setGeometry( QRect( 10, 330, 500, 27 ) ); QHBoxLayout* hlayout2 = new QHBoxLayout( privateLayoutWidget_2, 0, 6); lblNOfSongs = new QLabel( privateLayoutWidget_2); lblNOfSongs.setText( tr( "Number of Songs" ) ); hlayout2.addWidget( lblNOfSongs ); fieldNOfSongs = new QLineEdit( privateLayoutWidget_2);
			 * fieldNOfSongs.setMaximumSize(QSize(60,20)); //fieldNOfSongs.setEnabled( false ); //fieldNOfSongs.setText( tr( "1" ) ); hlayout2.addWidget( fieldNOfSongs ); lblStatus = new QLabel( privateLayoutWidget_2); lblStatus.setText( tr( "Status" ) ); hlayout2.addWidget( lblStatus ); cmbStatus = new QComboBox( false, privateLayoutWidget_2);
			 * cmbStatus.insertItem( tr( "Planning" ) ); cmbStatus.insertItem( tr( "Rehearsals" ) ); cmbStatus.insertItem( tr( "Recording" ) ); cmbStatus.insertItem( tr( "Finishing" ) ); cmbStatus.insertItem( tr( "Tournee" ) ); cmbStatus.setMaximumSize( QSize( 140, 28 ) ); hlayout2.addWidget( cmbStatus ); lblTotalDur = new QLabel(
			 * privateLayoutWidget_2); lblTotalDur.setText( tr( "Dur: ???" ) ); hlayout2.addWidget( lblTotalDur ); QWidget* privateLayoutWidget_3 = new QWidget( tab); privateLayoutWidget_3.setGeometry( QRect( 10, 360, 710, 24 ) ); QHBoxLayout* hlayout3 = new QHBoxLayout( privateLayoutWidget_3, 0, 6); lblEngineer = new QLabel(
			 * privateLayoutWidget_3); lblEngineer.setMinimumSize( QSize( 95, 0 ) ); lblEngineer.setText( tr( "Protux Engineer" ) ); hlayout3.addWidget( lblEngineer ); fieldEngineer = new QLineEdit( privateLayoutWidget_3); hlayout3.addWidget( fieldEngineer ); QWidget* privateLayoutWidget_4 = new QWidget( tab ); privateLayoutWidget_4.setGeometry(
			 * QRect( 10, 420, 710, 24 ) ); QHBoxLayout* hlayout4 = new QHBoxLayout( privateLayoutWidget_4, 0, 6); btnRender = new QPushButton( privateLayoutWidget_4); btnRender.setText( tr( "Render ..." ) ); btnRender.setEnabled(false); connect( btnRender, SIGNAL(clicked()), this, SLOT(btnRender_clicked())); //QToolTip.add( btnRender, tr( "Render
			 * all underendered elements. Do this before burning a CD" ) ); hlayout4.addWidget( btnRender ); btnMaster = new QPushButton( privateLayoutWidget_4); btnMaster.setEnabled( false ); btnMaster.setText( tr( "Master ..." ) ); connect( btnMaster, SIGNAL(clicked()), this, SLOT(btnMaster_clicked())); //QToolTip.add( btnMaster, tr( "Opens the
			 * masterization dialog" ) ); hlayout4.addWidget( btnMaster ); btnBurnCD = new QPushButton( privateLayoutWidget_4); btnBurnCD.setEnabled( false ); connect( btnBurnCD, SIGNAL(clicked()), this, SLOT(btnBurnCD_clicked())); //QFont btnBurnCD_font( btnBurnCD.font() ); //btnBurnCD_font.setFamily( "Helvetica" ); //btnBurnCD_font.setPointSize(
			 * 10 ); //btnBurnCD_font.setBold( TRUE ); //btnBurnCD.setFont( btnBurnCD_font ); btnBurnCD.setText( tr( "Burn CD" ) ); hlayout4.addWidget( btnBurnCD ); QWidget* privateLayoutWidget_5 = new QWidget( tab ); privateLayoutWidget_5.setGeometry( QRect( 10, 390, 710, 24 ) ); QHBoxLayout* hlayout5 = new QHBoxLayout( privateLayoutWidget_5, 0,
			 * 6); btnCreateProject = new QPushButton( privateLayoutWidget_5 ); btnCreateProject.setText( tr( "CREATE NEW" ) ); hlayout5.addWidget( btnCreateProject ); connect( btnCreateProject, SIGNAL(clicked()), this, SLOT(btnCreateProject_clicked())); btnLoadProject = new QPushButton( privateLayoutWidget_5 ); btnLoadProject.setText( tr( "LOAD" ) );
			 * connect( btnLoadProject, SIGNAL(clicked()), this, SLOT(btnLoadProject_clicked())); //QToolTip.add( btnSaveProject, tr( "Load this album project (Save your current project first !!!)" ) ); hlayout5.addWidget( btnLoadProject ); btnSaveProject = new QPushButton( privateLayoutWidget_5 ); btnSaveProject.setText( tr( "SAVE" ) ); connect(
			 * btnSaveProject, SIGNAL(clicked()), this, SLOT(btnSaveProject_clicked())); //QToolTip.add( btnSaveProject, tr( "Save all Song projects under this album project" ) ); hlayout5.addWidget( btnSaveProject ); btnCopyToProject = new QPushButton( privateLayoutWidget_5 ); btnCopyToProject.setText( tr( "Save as" ) ); connect( btnCopyToProject,
			 * SIGNAL(clicked()), this, SLOT(btnCopyToProject_clicked())); //QToolTip.add( btnCopyToProject, tr( "Copy this project to another project" ) ); hlayout5.addWidget( btnCopyToProject ); fieldSaveProjAs = new QLineEdit( privateLayoutWidget_5 ); hlayout5.addWidget( fieldSaveProjAs ); btnDeleteProject = new QPushButton(
			 * privateLayoutWidget_5 ); connect( btnDeleteProject, SIGNAL(clicked()), this, SLOT(btnDeleteProject_clicked())); btnDeleteProject.setText( tr( "DELETE" ) ); //QToolTip.add( btnDeleteProject, tr( "Delete current project (DANGER)" ) ); hlayout5.addWidget( btnDeleteProject ); listAlbumProjects = new QListView( tab );
			 * listAlbumProjects.addColumn( tr( "Album Name" ) ); listAlbumProjects.addColumn( tr( "N. of Songs" ) ); listAlbumProjects.addColumn( tr( "Space Alloc" ) ); listAlbumProjects.addColumn( tr( "Status" ) ); listAlbumProjects.setColumnAlignment( 1, Qt.AlignHCenter ); listAlbumProjects.setColumnAlignment( 3, Qt.AlignHCenter );
			 * listAlbumProjects.setGeometry( QRect( 10, 10, 710, 280 ) ); connect(listAlbumProjects, SIGNAL(selectionChanged()), this, SLOT(listAlbumProject_projectSelected())); mainTabPane.insertTab( tab, tr( "Album Projects" ) ); // Songs tab ---------------------------------------------------------- tab_2 = new QWidget( mainTabPane ); QWidget*
			 * privateLayoutWidget_6 = new QWidget( tab_2); privateLayoutWidget_6.setGeometry( QRect( 10, 430, 710, 22 ) ); QHBoxLayout* hlayout6 = new QHBoxLayout( privateLayoutWidget_6, 0, 6); lblMasterGain = new QLabel( privateLayoutWidget_6 ); lblMasterGain.setMinimumSize( QSize( 69, 0 ) ); lblMasterGain.setText( tr( "Master Gain" ) );
			 * hlayout6.addWidget( lblMasterGain ); fieldMasterGain = new QLineEdit( privateLayoutWidget_6 ); fieldMasterGain.setText( tr( "0.0" ) ); hlayout6.addWidget( fieldMasterGain ); lblNumTracks = new QLabel( privateLayoutWidget_6 ); lblNumTracks.setMinimumSize( QSize( 70, 0 ) ); lblNumTracks.setText( tr( "Num. Tracks" ) );
			 * hlayout6.addWidget( lblNumTracks ); fieldNumTracks = new QLineEdit( privateLayoutWidget_6); fieldNumTracks.setText( tr( "" ) ); fieldNumTracks.setEnabled(false); //QToolTip.add( fieldNumTracks, tr( "To add/remove tracks, use standard JMB actions , such <INSERT> or <DELETE>, right inside MTA" ) ); hlayout6.addWidget( fieldNumTracks );
			 * lblSongDur = new QLabel( privateLayoutWidget_6); lblSongDur.setMinimumSize( QSize( 56, 0 ) ); lblSongDur.setText( tr( "Duration" ) ); lblSongDur.setScaledContents( false ); hlayout6.addWidget( lblSongDur ); fieldSongDur = new QLineEdit( privateLayoutWidget_6 ); fieldSongDur.setText( tr( "??" ) ); fieldNumTracks.setEnabled(false);
			 * hlayout6.addWidget( fieldSongDur ); QWidget* privateLayoutWidget_7 = new QWidget( tab_2); privateLayoutWidget_7.setGeometry( QRect( 10, 400, 710, 24 ) ); QHBoxLayout* hlayout7 = new QHBoxLayout( privateLayoutWidget_7, 0, 6); lblArtist = new QLabel( privateLayoutWidget_7); lblArtist.setMinimumSize( QSize( 60, 0 ) ); lblArtist.setText(
			 * tr( "Artists" ) ); hlayout7.addWidget( lblArtist ); fieldArtists = new QLineEdit( privateLayoutWidget_7); hlayout7.addWidget( fieldArtists ); QWidget* privateLayoutWidget_8 = new QWidget( tab_2 ); privateLayoutWidget_8.setGeometry( QRect( 10, 370, 710, 22 ) ); QHBoxLayout* hlayout8 = new QHBoxLayout( privateLayoutWidget_8, 0, 6);
			 * TextLabel2 = new QLabel( privateLayoutWidget_8 ); //TextLabel2.setText( tr( "Song : Au revoir" ) ); hlayout8.addWidget( TextLabel2 ); QWidget* privateLayoutWidget_9 = new QWidget( tab_2 ); privateLayoutWidget_9.setGeometry( QRect( 10, 320, 710, 24 ) ); QHBoxLayout* hlayout9 = new QHBoxLayout( privateLayoutWidget_9, 0, 6); btnSaveSong =
			 * new QPushButton( privateLayoutWidget_9 ); btnSaveSong.setMinimumSize( QSize( 80, 0 ) ); btnSaveSong.setText( tr( "SAVE" ) ); //QToolTip.add( btnSaveSong, tr( "Save this song project" ) ); hlayout9.addWidget( btnSaveSong ); btnSaveSongAs = new QPushButton( privateLayoutWidget_9); btnSaveSongAs.setMinimumSize( QSize( 80, 0 ) );
			 * btnSaveSongAs.setText( tr( "Rename" ) ); //QToolTip.add( btnSaveSongAs, tr( "Add a new song which is a copy of current song" ) ); hlayout9.addWidget( btnSaveSongAs ); lblOr = new QLabel( privateLayoutWidget_9 ); lblOr.setText( tr( "or" ) ); hlayout9.addWidget( lblOr ); btn = new QPushButton( privateLayoutWidget_9 );
			 * btn.setMinimumSize( QSize( 80, 0 ) ); btn.setText( tr( "COPY as" ) ); btn.setEnabled( false ); //QToolTip.add( btn, tr( "add an empty song project" ) ); hlayout9.addWidget( btn ); fieldCopyTo = new QLineEdit( privateLayoutWidget_9 ); fieldCopyTo.setMinimumSize( QSize( 410, 0 ) ); fieldCopyTo.setMaximumSize( QSize( 300, 30 ) );
			 * hlayout9.addWidget( fieldCopyTo ); listSongs = new QListView( tab_2, "listSongs" ); listSongs.addColumn( tr( "Song Name" ) ); listSongs.addColumn( tr( "Tracks" ) ); listSongs.addColumn( tr( "Lenght h:m:s,fr" ), 110 ); listSongs.addColumn( tr( "Rate" ), 65 ); listSongs.addColumn( tr( "Bit Depth" ) ); listSongs.addColumn( tr( "Status" ),
			 * 85 ); listSongs.addColumn( tr( "Space Alloc" ) ); listSongs.setColumnAlignment( 1, Qt.AlignHCenter ); listSongs.setColumnAlignment( 2, Qt.AlignHCenter ); listSongs.setColumnAlignment( 3, Qt.AlignHCenter ); listSongs.setColumnAlignment( 4, Qt.AlignHCenter ); listSongs.setColumnAlignment( 5, Qt.AlignHCenter );
			 * listSongs.setColumnAlignment( 6, Qt.AlignHCenter ); Object obj item = new QListViewItem( listSongs, 0 ); item.setText( 0, tr( "Untitled Song" ) ); listSongs.setGeometry( QRect( 10, 10, 710, 310 ) ); QWidget* privateLayoutWidget_91 = new QWidget( tab_2 ); privateLayoutWidget_91.setGeometry( QRect( 10, 350, 360, 30 ) ); QHBoxLayout*
			 * hlayout10 = new QHBoxLayout( privateLayoutWidget_91, 0, 6); btnNewSong = new QPushButton( privateLayoutWidget_91); btnNewSong.setMinimumSize( QSize( 80, 25 ) ); btnNewSong.setMaximumSize( QSize( 120, 25 ) ); btnNewSong.setText( tr( "NEW" ) ); //QToolTip.add( btnNewSong, tr( "Create a New Song" ) ); hlayout10.addWidget( btnNewSong ); //
			 * btnRemoveSongFromProject = new QPushButton( privateLayoutWidget_91 ); // btnRemoveSongFromProject.setMinimumSize( QSize( 80, 0 ) ); // btnRemoveSongFromProject.setText( tr( "Remove Song from Project" ) ); // //QToolTip.add( btnSaveSong, tr( "Save this song project" ) ); // hlayout10.addWidget( btnRemoveSongFromProject );
			 * btnDeleteSong = new QPushButton( privateLayoutWidget_91 ); btnDeleteSong.setMinimumSize( QSize( 80, 0 ) ); btnDeleteSong.setMaximumSize( QSize( 120, 25 ) ); btnDeleteSong.setText( tr( "Delete Song" ) ); //QToolTip.add( btnSaveSong, tr( "Save this song project" ) ); hlayout10.addWidget( btnDeleteSong ); cmbSongStatus = new QComboBox(
			 * false, privateLayoutWidget_91 ); cmbSongStatus.insertItem( tr( "Planning" ) ); cmbSongStatus.insertItem( tr( "Rehearsals" ) ); cmbSongStatus.insertItem( tr( "Recording" ) ); cmbSongStatus.insertItem( tr( "Finishing" ) ); cmbSongStatus.insertItem( tr( "Tournee" ) ); cmbSongStatus.setMaximumSize( QSize( 120, 25 ) );
			 * hlayout10.addWidget( cmbSongStatus ); mainTabPane.insertTab( tab_2, tr( "Songs" ) ); connect(listSongs, SIGNAL(selectionChanged()), this, SLOT(listSongs_songSelected())); connect(btnSaveSong, SIGNAL(clicked()), this, SLOT(btnSaveSong_clicked())); connect( btnSaveSongAs, SIGNAL(clicked()), this, SLOT(btnSaveSongAs_clicked()));
			 * connect( btn, SIGNAL(clicked()), this, SLOT(btnSaveSongCopyAs_clicked())); connect( btnNewSong, SIGNAL(clicked()), this, SLOT(btnNewSong_clicked())); // connect(btnRemoveSongFromProject, SIGNAL(clicked()), this, SLOT(btnRemoveSongFromProject_clicked())); connect(btnDeleteSong, SIGNAL(clicked()), this, SLOT(btnDeleteSong_clicked())); //
			 * Audio Sources tab ----------------------------------------------- tab_3 = new QWidget( mainTabPane ); QVBoxLayout* audioSourcesViewerLayout = new QVBoxLayout( tab_3, 11, 6, "audioSourcesViewerLayout"); audioListView = new QListView( tab_3 ); audioSourcesViewerLayout.addWidget( audioListView ); audioListView.addColumn( tr( "Name" ) );
			 * audioListView.addColumn( tr( "Type" ) ); audioListView.addColumn( tr( "Lenght" ) ); audioListView.addColumn( tr( "Size" ) ); audioListView.addColumn( tr( "Clips" ) ); audioListView.addColumn( tr( "Filters" ) ); audioListView.addColumn( tr( "Rate" ) ); audioListView.addColumn( tr( "Channels" ) ); audioListView.addColumn( tr( "Bit
			 * Depth" ) ); audioListView.addColumn( tr( "Project" ) ); audioListView.addColumn( tr( "Group" ) ); audioListView.addColumn( tr( "Hardware" ) ); audioListView.addColumn( tr( "Description" ) ); QWidget* audioSourcesButtonsContainer = new QWidget( tab_3 ); // audioSourcesButtonsContainer.setGeometry( QRect( 10, 310, 700, 24 ) );
			 * audioSourcesViewerLayout.addWidget( audioSourcesButtonsContainer ); QHBoxLayout* hlayout11 = new QHBoxLayout( audioSourcesButtonsContainer, 0, 6); btnRemoveUnusedSources = new QPushButton( audioSourcesButtonsContainer); btnRemoveUnusedSources.setText( tr( "Remove Unused Audio Sources" ) ); hlayout11.addWidget( btnRemoveUnusedSources );
			 * btnDeleteSource = new QPushButton( audioSourcesButtonsContainer); btnDeleteSource.setText( tr( "Remove Audio Source" ) ); hlayout11.addWidget( btnDeleteSource ); btnRemoveAllAudioSources = new QPushButton( audioSourcesButtonsContainer); btnRemoveAllAudioSources.setText( tr( "Remove All Audio Sources" ) ); hlayout11.addWidget(
			 * btnRemoveAllAudioSources ); btnExportSource = new QPushButton( audioSourcesButtonsContainer); btnExportSource.setText( tr( "Export ..." ) ); hlayout11.addWidget( btnExportSource ); grpPreListenSource = new QGroupBox( tab_3); audioSourcesViewerLayout.addWidget( grpPreListenSource ); grpPreListenSource.setGeometry( QRect( 10, 340, 700,
			 * 110 ) ); grpPreListenSource.setTitle( tr( "Listen" ) ); lblDSPVol1 = new QLabel( grpPreListenSource ); lblDSPVol1.setText( tr( "Volume" ) ); lblDSPVol1.setGeometry( QRect( 150, 15, 80, 15) ); sliderSource = new QSlider( grpPreListenSource ); sliderSource.setRange( -72 , 72 ); sliderSource.setValue( -30 ); sliderSource.setMaximumSize(
			 * QSize( 180, 14 ) ); sliderSource.setOrientation( QSlider.Horizontal ); sliderSource.setGeometry( QRect( 85, 35, 190, 14 ) ); volumeSource = new QLabel( grpPreListenSource ); volumeSource.setGeometry( QRect( 87, 60, 180, 15 ) ); volumeSource.setMaximumSize ( QSize( 180 , 15 ) ); volumeSource.setText( tr( "-24 0 +24" ) ); btnSourcePlay =
			 * new QPushButton( grpPreListenSource); btnSourcePlay.setGeometry( QRect( 10, 28, 65, 27 ) ); btnSourcePlay.setLabel( tr( "Play" ) ); cmbPreListenBus = new QComboBox( false, grpPreListenSource); cmbPreListenBus.setGeometry( QRect( 270, 20, 100, 30 ) ); // TODO , fill with actual detected buses cmbPreListenBus.insertItem( tr( "AUTO" ) );
			 * cmbPreListenBus.insertItem( tr( "hw:0,0" ) ); cmbPreListenBus.insertItem( tr( "hw:1,0" ) ); cmbPreListenBus.insertItem( tr( "hw:2,0" ) ); cmbPreListenBus.insertItem( tr( "hw:3,0" ) ); cmbPreListenBus.insertItem( tr( "hw:4,0" ) ); fieldAudioSourceInfo = new QLineEdit( grpPreListenSource ); fieldAudioSourceInfo.setGeometry( QRect( 400,
			 * 20, 150, 70 ) ); lblSourceSpectro = new QLabel( grpPreListenSource ); lblSourceSpectro.setGeometry( QRect( 600, 40, 80, 15 ) ); lblSourceSpectro.setMaximumSize( QSize( 300, 15 ) ); lblSourceSpectro.setText( tr( "FFT & Peak" ) ); QWidget* privateLayoutWidget_12 = new QWidget( grpPreListenSource ); privateLayoutWidget_12.setGeometry(
			 * QRect( 10, 80, 260, 18 ) ); QHBoxLayout* hlayout13 = new QHBoxLayout( privateLayoutWidget_12, 0, 6); checkSourceInfo = new QCheckBox( privateLayoutWidget_12 ); checkSourceInfo.setEnabled( TRUE ); checkSourceInfo.setText( tr( "Auto Info" ) ); hlayout13.addWidget( checkSourceInfo ); checkSourceSpectro = new QCheckBox(
			 * privateLayoutWidget_12 ); checkSourceSpectro.setText( tr( "AutoSpectro" ) ); hlayout13.addWidget( checkSourceSpectro ); // signals and slots connections connect( audioListView, SIGNAL( itemRenamed(Object ,int) ), this, SLOT( audioListView_itemRenamed(Object ,int) ) ); connect( audioListView, SIGNAL( spacePressed(Object ) ), this,
			 * SLOT( audioListView_spacePressed(Object ) ) ); connect( audioListView, SIGNAL( returnPressed(Object ) ), this, SLOT( audioListView_returnPressed(Object ) ) ); connect( audioListView, SIGNAL( onItem(Object ) ), this, SLOT( audioListView_onItem(Object ) ) ); connect( audioListView, SIGNAL( collapsed(Object ) ), this, SLOT(
			 * audioListView_collapsed(Object ) ) ); connect( audioListView, SIGNAL( expanded(Object ) ), this, SLOT( audioListView_expanded(Object ) ) ); connect( btnDeleteSource, SIGNAL(clicked()), this, SLOT(btnDeleteSource_clicked())); connect( btnRemoveUnusedSources, SIGNAL(clicked()), this, SLOT(btnRemoveUnusedSources_clicked())); connect(
			 * btnRemoveAllAudioSources, SIGNAL(clicked()), this, SLOT(btnRemoveAllAudioSources_clicked())); connect( btnExportSource, SIGNAL(clicked()), this, SLOT(btnExportSource_clicked())); connect( sliderSource, SIGNAL(sliderMoved(int)), this, SLOT(sliderSource_moved())); connect( btnSourcePlay, SIGNAL(clicked()), this,
			 * SLOT(btnSourcePlay_clicked())); mainTabPane.insertTab( tab_3, tr( "Audio Sources" ) ); // File Browser ------------------------------------------------------ tab_4 = new QWidget( mainTabPane); fileBrowser = new FileBrowser(tab_4); fileBrowser.setMinimumSize(QSize(710,260)); grpPreListenFile = new QGroupBox( tab_4 );
			 * grpPreListenFile.setGeometry( QRect( 10, 340, 700, 110 ) ); grpPreListenFile.setTitle( tr( "Pre-listen" ) ); //QWidget* privateLayoutWidget_13 = new QWidget( grpPreListenFile); //privateLayoutWidget_13.setGeometry( QRect( 70, 20, 190, 30 ) ); //QHBoxLayout* hlayout14 = new QHBoxLayout( privateLayoutWidget_13, 1, 0); lblDSPVol2 = new
			 * QLabel( grpPreListenFile ); lblDSPVol2.setText( tr( "Volume" ) ); lblDSPVol2.setGeometry( QRect( 150, 15, 80, 15) ); //hlayout14.addWidget( lblDSPVol2 ); sliderFile = new QSlider( grpPreListenFile ); sliderFile.setRange( -72 , 72 ); sliderFile.setValue( -30 ); sliderFile.setMaximumSize( QSize( 180, 14 ) ); sliderFile.setOrientation(
			 * QSlider.Horizontal ); sliderFile.setGeometry( QRect( 85, 35, 190, 14 ) ); //hlayout14.addWidget( sliderFile ); volumeFile = new QLabel( grpPreListenFile ); volumeFile.setGeometry( QRect( 87, 53, 180, 15 ) ); volumeFile.setMaximumSize ( QSize( 180 , 15 ) ); volumeFile.setText( tr( "-24 0 +24" ) ); QWidget* privateLayoutWidget_14 = new
			 * QWidget( grpPreListenFile ); privateLayoutWidget_14.setGeometry( QRect( 10, 80, 260, 18 ) ); QHBoxLayout* hlayout15 = new QHBoxLayout( privateLayoutWidget_14, 0, 6); checkFileInfo = new QCheckBox( privateLayoutWidget_14 ); checkFileInfo.setEnabled( TRUE ); checkFileInfo.setText( tr( "Auto Info" ) ); hlayout15.addWidget( checkFileInfo );
			 * checkFileSpectro = new QCheckBox( privateLayoutWidget_14 ); checkFileSpectro.setText( tr( "AutoSpectro" ) ); hlayout15.addWidget( checkFileSpectro ); lblFileSpectro = new QLabel( grpPreListenFile ); lblFileSpectro.setGeometry( QRect( 570, 60, 80, 15 ) ); lblFileSpectro.setMaximumSize( QSize( 300, 15 ) ); lblFileSpectro.setText( tr(
			 * "FFT & Peak" ) ); fieldFileInfo = new QLineEdit( grpPreListenFile ); fieldFileInfo.setGeometry( QRect( 320, 20, 220, 70 ) ); btnFilePlay = new QPushButton( grpPreListenFile ); btnFilePlay.setGeometry( QRect( 10, 28, 65, 27 ) ); btnFilePlay.setLabel( tr( "Play" ) ); grpImportFile = new QGroupBox( tab_4 ); grpImportFile.setGeometry(
			 * QRect( 10, 260, 700, 80 ) ); grpImportFile.setTitle( tr( "Import" ) ); QWidget* privateLayoutWidget_15 = new QWidget( grpImportFile ); privateLayoutWidget_15.setGeometry( QRect( 20, 20, 670, 24 ) ); QHBoxLayout* hlayout16 = new QHBoxLayout( privateLayoutWidget_15, 0, 6); lblFileDestSong = new QLabel( privateLayoutWidget_15 );
			 * lblFileDestSong.setMaximumSize( QSize( 80, 30 ) ); lblFileDestSong.setText( tr( "Dest: Song" ) ); hlayout16.addWidget( lblFileDestSong ); fieldFileDestSong = new QLineEdit( privateLayoutWidget_15 ); fieldFileDestSong.setMaximumSize( QSize( 25, 30 ) ); fieldFileDestSong.setText( tr( "1" ) ); hlayout16.addWidget( fieldFileDestSong );
			 * lblFileDestTrack = new QLabel( privateLayoutWidget_15 ); lblFileDestTrack.setMaximumSize( QSize( 36, 30 ) ); lblFileDestTrack.setText( tr( "Track" ) ); hlayout16.addWidget( lblFileDestTrack ); fieldFileDestTrack = new QLineEdit( privateLayoutWidget_15 ); fieldFileDestTrack.setMaximumSize( QSize( 25, 30 ) );
			 * fieldFileDestTrack.setText( tr( "1" ) ); hlayout16.addWidget( fieldFileDestTrack ); lblFileDestPos = new QLabel( privateLayoutWidget_15 ); lblFileDestPos.setMaximumSize( QSize( 25, 30 ) ); lblFileDestPos.setText( tr( "Pos" ) ); hlayout16.addWidget( lblFileDestPos ); fieldFileDestPos = new QLineEdit( privateLayoutWidget_15 );
			 * fieldFileDestPos.setMinimumSize( QSize( 77, 0 ) ); fieldFileDestPos.setMaximumSize( QSize( 55, 30 ) ); fieldFileDestPos.setText( tr( "0:02:30,14" ) ); hlayout16.addWidget( fieldFileDestPos ); btnAddFileAsSource = new QPushButton( privateLayoutWidget_15 ); btnAddFileAsSource.setText( tr( "Add as Audio Source" ) ); //QToolTip.add(
			 * btnAddFileAsSource, tr( "Add this file/cd-track to song project as an audio source" ) ); hlayout16.addWidget( btnAddFileAsSource ); btnImportFileNow = new QPushButton( privateLayoutWidget_15 ); btnImportFileNow.setLabel( tr( "Import now!" ) ); //QToolTip.add( btnImportFileNow, tr( "Add this file/cd-track to song project as an audio
			 * source" ) ); hlayout16.addWidget( btnImportFileNow ); QWidget* privateLayoutWidget_16 = new QWidget( grpImportFile ); privateLayoutWidget_16.setGeometry( QRect( 20, 50, 670, 22 ) ); QHBoxLayout* hlayout17 = new QHBoxLayout( privateLayoutWidget_16, 0, 6); pbarFileImport = new QProgressBar( privateLayoutWidget_16, "pbarFileImport" );
			 * pbarFileImport.setProgress( 0 ); hlayout17.addWidget( pbarFileImport ); checkFileFakeImport = new QCheckBox( privateLayoutWidget_16 ); checkFileFakeImport.setText( tr( "Fake Import" ) ); //QToolTip.add( checkFileFakeImport, tr( "Just import the audio source, spending the same amout of time, but does not put it into the song as audio
			 * source" ) ); hlayout17.addWidget( checkFileFakeImport ); mainTabPane.insertTab( tab_4, "File Browser" ); // signals and slots connections connect( sliderFile, SIGNAL(sliderMoved(int)), this, SLOT(sliderFile_moved())); connect( btnFilePlay, SIGNAL(clicked()), this, SLOT(btnFilePlay_clicked())); connect( btnAddFileAsSource,
			 * SIGNAL(clicked()), this, SLOT(btnAddFileAsSource_clicked())); connect( btnImportFileNow, SIGNAL(clicked()), this, SLOT(btnImportNow_clicked())); // CD BROWSER --------------------------------------------------------- tab_5 = new QWidget( mainTabPane, "tab_5" ); lblCDBrowser_2 = new QLabel( tab_5 ); lblCDBrowser_2.setGeometry( QRect(
			 * 290, 160, 120, 20 ) ); lblCDBrowser_2.setText( tr( "Audio CD Browser" ) ); grpImportCDA = new QGroupBox( tab_5 ); grpImportCDA.setGeometry( QRect( 10, 260, 700, 80 ) ); grpImportCDA.setTitle( tr( "Import" ) ); QWidget* privateLayoutWidget_17 = new QWidget( grpImportCDA ); privateLayoutWidget_17.setGeometry( QRect( 20, 20, 670, 24 ) );
			 * QHBoxLayout* hlayout18 = new QHBoxLayout( privateLayoutWidget_17, 0, 6); lblDestSongCDA = new QLabel( privateLayoutWidget_17 ); lblDestSongCDA.setMaximumSize( QSize( 80, 30 ) ); lblDestSongCDA.setText( tr( "Dest: Song" ) ); hlayout18.addWidget( lblDestSongCDA ); fieldDestSongCDA = new QLineEdit( privateLayoutWidget_17 );
			 * fieldDestSongCDA.setMaximumSize( QSize( 25, 30 ) ); fieldDestSongCDA.setText( tr( "1" ) ); hlayout18.addWidget( fieldDestSongCDA ); lblDestTrackCDA = new QLabel( privateLayoutWidget_17 ); lblDestTrackCDA.setMaximumSize( QSize( 36, 30 ) ); lblDestTrackCDA.setText( tr( "Track" ) ); hlayout18.addWidget( lblDestTrackCDA );
			 * fieldDestTrackCDA = new QLineEdit( privateLayoutWidget_17 ); fieldDestTrackCDA.setMaximumSize( QSize( 25, 30 ) ); fieldDestTrackCDA.setText( tr( "1" ) ); hlayout18.addWidget( fieldDestTrackCDA ); lblDestPosCDA = new QLabel( privateLayoutWidget_17 ); lblDestPosCDA.setMaximumSize( QSize( 25, 30 ) ); lblDestPosCDA.setText( tr( "Pos" ) );
			 * hlayout18.addWidget( lblDestPosCDA ); fieldDestPosCDA = new QLineEdit( privateLayoutWidget_17 ); fieldDestPosCDA.setMinimumSize( QSize( 77, 0 ) ); fieldDestPosCDA.setMaximumSize( QSize( 55, 30 ) ); fieldDestPosCDA.setText( "0:02:30,14" ); hlayout18.addWidget( fieldDestPosCDA ); btnAddSourceCDA = new QPushButton(
			 * privateLayoutWidget_17 ); connect( btnAddSourceCDA, SIGNAL(clicked()), this, SLOT(btnAddSourceCDA_clicked())); btnAddSourceCDA.setText( tr( "Add as Audio Source" ) ); //QToolTip.add( btnAddSourceCDA, tr( "Add this file/cd-track to song project as an audio source" ) ); hlayout18.addWidget( btnAddSourceCDA ); btnImportNowCDA = new
			 * QPushButton( privateLayoutWidget_17 ); connect( btnImportNowCDA, SIGNAL(clicked()), this, SLOT(btnImportNowCDA_clicked())); btnImportNowCDA.setText( tr( "Import now!" ) ); //QToolTip.add( btnImportNowCDA, tr( "Add this file/cd-track to song project as an audio source" ) ); hlayout18.addWidget( btnImportNowCDA ); QWidget*
			 * privateLayoutWidget_18 = new QWidget( grpImportCDA); privateLayoutWidget_18.setGeometry( QRect( 20, 50, 670, 22 ) ); QHBoxLayout* hlayout19 = new QHBoxLayout( privateLayoutWidget_18, 0, 6); pbarImportCDA = new QProgressBar( privateLayoutWidget_18 ); pbarImportCDA.setProgress( 0 ); hlayout19.addWidget( pbarImportCDA );
			 * checkFakeImportCDA = new QCheckBox( privateLayoutWidget_18 ); checkFakeImportCDA.setText( tr( "Fake Import" ) ); //QToolTip.add( checkFakeImportCDA, tr( "Just import the audio source, spending the same amout of time, but does not put it into the song as audio source" ) ); hlayout19.addWidget( checkFakeImportCDA ); grpPreListenCDA =
			 * new QGroupBox( tab_5 ); grpPreListenCDA.setGeometry( QRect( 10, 340, 700, 110 ) ); grpPreListenCDA.setTitle( tr( "Pre-listen" ) ); QWidget* privateLayoutWidget_19 = new QWidget( grpPreListenCDA); privateLayoutWidget_19.setGeometry( QRect( 10, 50, 260, 16 ) ); QHBoxLayout* hlayout20 = new QHBoxLayout( privateLayoutWidget_19, 0, 6);
			 * lblCDAVol = new QLabel( privateLayoutWidget_19 ); lblCDAVol.setText( tr( "Vol" ) ); hlayout20.addWidget( lblCDAVol ); sliderCDA = new QSlider( privateLayoutWidget_19 ); sliderCDA.setMaximumSize( QSize( 300, 14 ) ); sliderCDA.setOrientation( QSlider.Horizontal ); hlayout20.addWidget( sliderCDA ); btnCDAPlay = new QPushButton(
			 * grpPreListenCDA ); connect( btnCDAPlay, SIGNAL(clicked()), this, SLOT(btnCDAPlay_clicked())); btnCDAPlay.setGeometry( QRect( 10, 20, 260, 22 ) ); btnCDAPlay.setText( tr( "Play" ) ); mainTabPane.insertTab( tab_5, tr( "Audio CD Browser" ) ); mainTabPane.setCurrentPage ( 0 );
			 */
			update_audio_sources_list();
			update_projects_list();
			update_song_list();
			return 1;
			}


		/*
		 * MIG JmbSlot show(JmbMessage* m) { if (!created) { if (create_dialog()) created = true; else return (MustuxAction*) 0; } QWidget.show(); return (MustuxAction*) 0; }
		 */


		public static ProjectManager getManager()
			{
			return manager;
			}


		public static boolean currentProjectIsPlaying()
			{
			return false;
			}


		public static int numProjects()
			{
			File f = new File(GlobalProperties.getProjectsBaseDir());
			File[] list = f.listFiles();
			int np = list.length;
			return np;
			}


		public static void createFirstProject()
			{
			if (Popup.confirm("No projects were found on your protux workspace. Create a default one ?"))
				{
				manager.createNewProject();
				}
			}


		public static void popup()
			{
			manager.refreshProjects();
			manager.setVisible(true);
			}


		protected void openSelectedProject()
			{
			String projName = (String) list.getSelectedValue();
			if (projName != null)
				{
				Project proj;
				try
					{
					proj = loadProject(projName);
					proj.recreate();
					this.setVisible(false);
					}
				catch (IOException e1)
					{
					Popup.warn("Opening " + projName + " failed : " + e1);
					}
				}

			}
	}
