package org.protux.core.gui;


public abstract class Rectangle
	{
		public int baseX;
		public int baseY;
		public int width;
		public int height;
		protected FastPanel canvas;


		public Rectangle(FastPanel canvas, int x, int y, int w, int h)
			{
			this.canvas = canvas;
			this.baseX = x;
			this.baseY = y;
			this.width = w;
			this.height = h;
			}


		public boolean contains(int x, int y)
			{
			return (baseX <= x) && (baseX + width >= x) && (baseY <= y) && (baseY + height >= y);
			}


		public abstract void clicked(int x, int y);


		protected abstract void draw();


		protected void repaint()
			{
			canvas.repaint(this);
			}

	}
