package org.protux.core.gui.dialogs;

import java.awt.Button;
import java.awt.Choice;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;

import static org.protux.core.Debugger.*;
import org.protux.core.editor.Song;


public class SongPropertiesDialog extends JFrame implements ActionListener
	{

	Song assocSong;

	Label label1;
	Label label2;
	Button buttonOK;
	Button buttonCancel;
	Choice comboBitDepth;
	Choice comboSampleRate;


	public SongPropertiesDialog(Song pAssocSong)

		{
		super("Song Properties");
		assocSong = pAssocSong;
		setTitle("Song Properties");

		this.setLayout(new GridLayout(3, 2));
		label2 = new Label("Bit Depth");
		this.add(label2);
		label2.setMaximumSize(new Dimension(97, 25));
		comboBitDepth = new Choice();
		comboBitDepth.add("16");
		this.add(comboBitDepth);
		comboBitDepth.setMaximumSize(new Dimension(190, 32));

		label1 = new Label("Sample Rate");
		this.add(label1);
		label1.setBounds(10, 50, 111, 25);
		comboSampleRate = new Choice();
		comboSampleRate.add("22050");
		comboSampleRate.add("32000");
		comboSampleRate.add("44100");
		comboSampleRate.add("48000");
		comboSampleRate.add("96000");
		this.add(comboSampleRate);
		comboSampleRate.setBounds(140, 50, 190, 32);

		buttonOK = new Button("APPLY AND SAVE");
		this.add(buttonOK);
		buttonOK.setBounds(40, 140, 140, 35);

		buttonCancel = new Button("CLOSE <ESC>");
		buttonCancel.setSize(120, 35);
		this.add(buttonCancel);

		buttonOK.addActionListener(this);
		buttonCancel.addActionListener(this);
		}


	int get_rate()
		{
		String s = comboSampleRate.getSelectedItem();
		return Integer.parseInt(s);
		}


	int get_bit_depth()
		{
		String s = comboBitDepth.getSelectedItem();
		return Integer.parseInt(s);
		}


	void apply()
		{
		if (assocSong!=null)
			{
			assocSong.changeSettings(get_rate(), get_bit_depth());
			}
		}


	public void exec()
		{
		setSize(520, 190);
		setVisible(true);
		}

	

	void updateThings()
		{
		int rate;
		int bitDepth;
		rate = assocSong.rate;
		bitDepth = assocSong.bitDepth;
		PMESG(3, "Updating Song Properties Dialog with rate=%d bitDepth=%d" + rate + bitDepth);
		if (rate == 22050)
			comboSampleRate.select(0);
		else if (rate == 32000)
			comboSampleRate.select(1);
		else if (rate == 44100)
			comboSampleRate.select(2);
		else if (rate == 48000)
			comboSampleRate.select(3);
		else if (rate == 96000)
			comboSampleRate.select(4);
		else
			comboSampleRate.select(2);
		}



	public void actionPerformed(ActionEvent ev)
		{
		Button b = (Button) ev.getSource();
		if (b==buttonOK)
			{
			apply();
			dispose();
			}
		else if (b==buttonCancel)
			{
			dispose();
			}
		}

	/** Unit Tester*/
	public static void main(String[] args) 
		{
		SongPropertiesDialog d = new SongPropertiesDialog(null);
		d.exec();
		}



	}
