package org.protux.core.media.audio;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;

import org.protux.core.media.audio.AudioMedia;
import static org.protux.core.Debugger.*;

public class Ogg extends AudioMedia
	{
	//MIG OggVorbis_File vorbisFile;
	int currentSection;
	static final int OGG_READ_BUFFER_SIZE = 4096;
	char OGG_READ_BUFFER[] = new char[OGG_READ_BUFFER_SIZE];
	int excessSize;
	char EXCESS_OGG_READ_BUFFER[] = new char[OGG_READ_BUFFER_SIZE];
	char[] ringBuffer;
	int ringBufferSize;
	char[] rbS;
	char[] rbE;
	char[] ringBufferEnd;
	boolean realEof;


	public Ogg(File aFile) throws IOException
		{
		super(aFile,false, 0, true);
		bestFragSize = OGG_READ_BUFFER_SIZE;
		//MIG if (ov_open(file, &vorbisFile, NULL, 0) < 0)
		//MIG {
		//PERROR2("Input does not appear to be an Ogg bitstream.");
		//PEXIT2;
		//MIG return -1;
		//MIG }
		// check if it is seekable
		//MIG if (!ov_seekable(&vorbisFile))
		//MIG {
		//PERROR2("Ogg file is not seekable!");
		//PEXIT2;
		//MIG return -1;
		//MIG }
		excessSize = 0;
		//MIG realEof=false;
		//MIG ringBuffer = null;
		}


	public void finalize()
		{
		//MIG ringBuffer = null;
		closeFile();
		}




	public void readHeader() throws IOException
		{
		//PENTER2;
		rewindAll();
		//MIG vorbis_info *vi = ov_info ( &vorbisFile , -1 );
		//MIG rate = (int) vi.rate ;
		bitDepth = 16; // FIXME !!
		//MIG channels = vi.channels;
		//MIG totalBlocks = (long ) ov_pcm_total(&vorbisFile,-1);
		bytesPerSec = rate * channels * (bitDepth / 8);
		blockSize = channels * (bitDepth / 8);
		sampleSize = blockSize / channels;
		audioSize = totalBlocks * blockSize;
		//MIG if (ringBuffer)ringBuffer = null;
		ringBufferSize = rate * blockSize;
		ringBuffer = new char[rate * blockSize]; // 1 second of audio
		//MIG rbS = ringBuffer + (ringBufferSize/2);
		rbE = rbS; // when rbS==rbE, it means the ring is empty
		//MIG ringBufferEnd = ringBuffer + ringBufferSize;
		excessSize = 0;
		realEof = false;
		fill_ring();
		skipHeader();
		}


	public void write_header(int pChannels, int pRate, int pBitDepth, long newAudioSize, String newProjectLabel, String newGroupLabel, String newHardwareLabel, String newDescription) throws IOException
		{
		PERROR("Mustux OggVorbis support is READ-ONLY !");
		}


	public AudioMedia copyTo(File file) 
		{
		return null;
		}


	@Override
	public void  appendSamplesFromFile(AudioMedia f) throws IOException
		{
		PERROR("Mustux OggVorbis support is READ-ONLY !");
		}


	@Override
	public void appendSamplesFromBuffer(byte[] buffer, int bufferSize) throws IOException
		{
		PERROR("Mustux OggVorbis support is READ-ONLY !");
		}


	@Override
	public void fixAudioSize()
		{
		PERROR("Mustux OggVorbis support is READ-ONLY !");
		}


	@Override
	public void blockSeek(long blockPos)
		{
		int r = 0;//MIG ov_pcm_seek(&vorbisFile, (ogg_int64_t) blockPos);
		/*MIG if (r==OV_ENOSEEK)
		 {
		 //PERROR2("Bitstream is not seekable");
		 }
		 else if (r==OV_EINVAL)
		 {
		 //PERROR2("Invalid argument value");
		 }
		 else if (r==OV_EREAD)
		 {
		 //PERROR2("A read from media returned an error");
		 }
		 else if (r==OV_EFAULT)
		 {
		 //PERROR2("Internal Ogg Stream Logic fault; indicates a bug or heap/stack corruption");
		 }
		 else if (r==OV_EBADLINK)
		 {
		 //PERROR2("Invalid stream section supplied to libvorbisfile, or the requested link is corrupt");
		 }*/
		}


	@Override
	public long blockTell()
		{
		return 0;//MIG (long ) ov_pcm_tell(&vorbisFile);
		}



	@Override
	public int readFragment(byte[] buf, int bufSize)
		{
		//PENTER3;
		//System.out.println("Consuming %d bytes ... \n" ,bufSize);
		/*MIG 
		 
		 int bytesRead=0;
		 if (rbS < rbE)
		 {
		 if  (rbS + bufSize <  rbE )
		 {
		 memcpy(buf,rbS,bufSize);
		 rbS += bufSize;
		 bytesRead = bufSize;
		 }
		 else // overrun !
		 {
		 memcpy(buf,rbS,rbE - rbS);
		 bytesRead = rbE - rbS;
		 rbS = rbE;
		 //System.out.println("\tOverrun !\n");
		 }
		 }
		 else
		 {
		 if ( rbS+bufSize < ringBufferEnd )
		 {
		 memcpy(buf,rbS,bufSize);
		 rbS += bufSize;
		 bytesRead = bufSize;
		 }
		 else
		 {
		 bytesRead = ringBufferEnd - rbS;
		 memcpy(buf,rbS,bytesRead);
		 rbS = ringBuffer;
		 buf += bytesRead;
		 int bytesYetToRead = bufSize - bytesRead;
		 if  (rbS + bytesYetToRead <  rbE )
		 {
		 memcpy(buf,rbS,bytesYetToRead);
		 rbS += bytesYetToRead;
		 bytesRead += bytesYetToRead;
		 }
		 else // overrun !
		 {
		 memcpy(buf,rbS,rbE - rbS);
		 rbS = rbE;
		 bytesRead += (rbE - rbS);
		 //System.out.println("\tOverrun !\n");
		 }
		 }
		 }

		 //show_ring_status();
		 fill_ring();
		 //PEXIT3;
		 
		 */
		return 0;//MIG bytesRead;
		}


	int fill_ring()
		{
		int totalBytesFeeded = 0;
		if (excessSize > 0)
			{
			//System.out.println("Compensating excess : ");
			if (feed_ring(EXCESS_OGG_READ_BUFFER, excessSize) > 0)
				{
				//System.out.println("Still excess ??!? ( exceed %d bytes even after the compensation )\n",excessSize);
				}
			}
		while (excessSize == 0)
			{
			//MIG int bytesRead = (int) ov_read(&vorbisFile,OGG_READ_BUFFER,OGG_READ_BUFFER_SIZE,0,2,1,&currentSection);
			if (false)//MIG bytesRead == 0)
				{
				realEof = true;
				break;
				}
			if (false)//MIG bytesRead < 0)
				{
				//PERROR2("Cannot read from file");
				return -1;
				}
			int bytesFeeded = 0;//MIG feed_ring(OGG_READ_BUFFER,bytesRead);
			totalBytesFeeded += bytesFeeded;
			realEof = false;
			}
		return totalBytesFeeded;
		}


	int feed_ring(char[] buf, int bufSize)
		{
		//System.out.println("Feeding %d bytes into ring ...\n" ,bufSize);
		/*MIG if (rbE >= rbS)
		 {
		 if (rbE + bufSize < ringBufferEnd)
		 {
		 //System.out.println("case 1\n");
		 memcpy(rbE,buf,bufSize);
		 rbE += bufSize;
		 excessSize=0;
		 }
		 else
		 {
		 int b1 = ringBufferEnd - rbE;
		 memcpy(rbE,buf,b1);
		 //System.out.println("\t Looping back...");
		 rbE = ringBuffer;
		 char[] pORB = buf + b1;
		 int b2 = bufSize - b1;
		 if  (rbE + b2 < rbS )
		 {
		 //System.out.println("case 2\n");
		 memcpy(rbE,pORB,b2);
		 rbE += b2;
		 excessSize=0;
		 }
		 else // end of ring
		 {
		 int remainBytes = (rbS-rbE)/2; // fill only half of remaining bytes, so it never loop-reaches the rbS
		 excessSize = b2 - remainBytes;
		 //System.out.println(" \t Can't feed %d bytes. Feeding only %d and saving %d for later...",b2,remainBytes,excessSize);
		 memcpy(rbE,pORB,remainBytes);
		 rbE += remainBytes;
		 memcpy(EXCESS_OGG_READ_BUFFER,pORB+remainBytes,excessSize);
		 }
		 }
		 }
		 else
		 {
		 if (rbE + bufSize < rbS)
		 {
		 memcpy(rbE,buf, bufSize);
		 rbE += bufSize;
		 excessSize=0;
		 }
		 else
		 {
		 int remainBytes = (rbS - rbE)/2;// fill only half of remaining bytes, so it never loop-reaches the rbS
		 excessSize = bufSize - remainBytes;
		 //System.out.println(" \t Can't feed %d bytes. Feeding only %d and saving %d for later...",bufSize,remainBytes,excessSize);
		 memcpy(rbE , buf , remainBytes);
		 rbE += remainBytes;
		 memcpy(EXCESS_OGG_READ_BUFFER , buf + remainBytes , excessSize);
		 }
		 }
		 //show_ring_status();
		 * 
		 */
		return 0;//MIG excessSize;
		}


	void show_ring_status()
		{
		/*MIG int avSize = (rbS<rbE) ? ringBufferSize - (rbE-rbS) : rbS-rbE;
		 System.out.println("Ring \t[ %d Free |  %d Used ] ",avSize,ringBufferSize-avSize);
		 if (rbS<rbE)
		 System.out.println("\t  (.....)  ");
		 else if (rbS>rbE)
		 System.out.println("\t....) (....");
		 else
		 System.out.println("\t.....O.....");
		 */
		}


	@Override
	public int writeFragment(byte[] frag) throws IOException
		{
		throw new IOException("Protux support for OggVorbis is READ-ONLY !");
		}


	@Override
	public void closeFile()
		{
		//MIG int r = ((ov_clear(&vorbisFile)==0)?1:-1);
		}


	@Override
	@Deprecated
	/**	Clients cannot access the phisical ogg file, since it is makes no sense to access encripted audio data directly
	 */
	public RandomAccessFile getFile()
		{
		PERROR("Trying to access the internal encripted ogg file.");
		return null;
		}


	@Override
	public int readFragment(byte[] frag)
		{
		// TODO Auto-generated method stub
		return 0;
		}


	}
