package org.protux.input.classic;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

import org.protux.core.Const;
import org.protux.core.Protux;

public class MainMenu extends JMenuBar implements ActionListener
	{
		private JMenu menuFile = new JMenu("File");
		private JMenu menuEdit = new JMenu("Edit");
		private JMenu menuView = new JMenu("View");
		private JMenu menuRoute = new JMenu("Route");
		private JMenuItem miProjectManager = new JMenuItem("Project Manager");
		private JMenuItem miImportAudio = new JMenuItem("Import Audio ...");
		private JMenuItem miSaveProject = new JMenuItem("Save Project");
		private JMenuItem miAddTrack = new JMenuItem("Add Audio Track");
		private JMenuItem miRemoveActiveTrack = new JMenuItem("Remove Track");
		private JMenuItem miQuit = new JMenuItem("Quit");
		private JMenuItem miZoomIn = new JMenuItem("Zoom In");
		private JMenuItem miZoomOut = new JMenuItem("Zoom Out");
		private JMenuItem miAddSoftIn = new JMenuItem("Add Soft In ...");
		private JMenuItem miAddSoftOut = new JMenuItem("Add Soft Out ...");
		private Protux app;


		public MainMenu(Protux app)
			{
			super();
			this.app = app;
			this.add(menuFile);
			this.add(menuEdit);
			this.add(menuView);
			this.add(menuRoute);

			menuFile.add(miProjectManager);
			menuFile.add(miImportAudio);
			menuFile.add(miSaveProject);
			menuFile.add(miQuit);
			miProjectManager.addActionListener(this);
			miQuit.addActionListener(this);
			miImportAudio.addActionListener(this);
			miSaveProject.addActionListener(this);
			if (Protux.isLive())
				{
				miProjectManager.setEnabled(false);
				miImportAudio.setEnabled(false);
				miSaveProject.setEnabled(false);
				miQuit.setEnabled(false);
				}

			menuEdit.add(miAddTrack);
			menuEdit.add(miRemoveActiveTrack);
			menuView.add(miZoomIn);
			menuView.add(miZoomOut);
			menuRoute.add(miAddSoftIn);
			menuRoute.add(miAddSoftOut);

			miZoomIn.addActionListener(this);
			miZoomOut.addActionListener(this);
			miAddSoftIn.addActionListener(this);
			miAddSoftOut.addActionListener(this);
			miAddTrack.addActionListener(this);
			miRemoveActiveTrack.addActionListener(this);
			}


		public void actionPerformed(ActionEvent arg0)
			{
			JMenuItem source = (JMenuItem) arg0.getSource();
			if (source == miProjectManager)
				{
				app.dispatchClassicAction(Const.ACTION_SHOW_PROJECT_MANAGER);
				}
			if (source == miQuit)
				{
				app.dispatchClassicAction(Const.ACTION_QUIT);
				}
			if (source == miImportAudio)
				{
				app.dispatchClassicAction(Const.ACTION_IMPORT_AUDIO);
				}
			if (source == miSaveProject)
				{
				app.dispatchClassicAction(Const.ACTION_SAVE_PROJECT);
				}
			if (source == miZoomIn)
				{
				app.dispatchClassicAction(Const.ACTION_ZOOM_IN);
				}
			if (source == miZoomOut)
				{
				app.dispatchClassicAction(Const.ACTION_ZOOM_OUT);
				}
			if (source == miAddSoftIn)
				{
				app.dispatchClassicAction(Const.ACTION_ADD_SOFT_IN);
				}
			if (source == miAddSoftOut)
				{
				app.dispatchClassicAction(Const.ACTION_ADD_SOFT_OUT);
				}
			if (source == miAddTrack)
				{
				app.dispatchClassicAction(Const.ACTION_ADD_TRACK);
				}
			if (source == miRemoveActiveTrack)
				{
				app.dispatchClassicAction(Const.ACTION_REMOVE_ACTIVE_TRACK);
				}

			}
	}
